<?php
class WP_YogaTimeTable_EpsRenderer extends WP_YogaTimeTable_Renderer {

//	private $_i = 1;
	protected $_wpytt;
	protected $_opts;
	protected $_css;
	private $_colors;
	private $_paperSizes = array (
		'Comm #10 Envelope' => array( '297', '684' ),
		'C5 Envelope'	=> array( '461', '648' ),
		'DL Envelope'	=> array( '312', '624' ),
		'Folio'			=> array( '595', '935' ),
		'Executive'		=> array( '522', '756' ),
		'Letter'		=> array( '612', '792' ),
		'Legal'			=> array( '612', '1008' ),
		'Ledger'		=> array( '1224', '792' ),
		'Tabloid'		=> array( '792', '1224' ),
		'A4'			=> array( '595', '842' ),
		'A5'			=> array( '420', '595' ),
		'A6'			=> array( '297', '420' ),
		'A7'			=> array( '210', '297' ),
		'A8'			=> array( '148', '210' ),
		'A9'			=> array( '105', '148' ),
		'B4'			=> array( '729', '595' ),
		'B5'			=> array( '516', '1032' ),
		'B6'			=> array( '363', '516' ),
		'B7'			=> array( '258', '363' ),
		'B8'			=> array( '258', '258' ),
		'B9'			=> array( '127', '258' ),
		'B10'			=> array( '91', '127' )
	);
	private $_paperSize;
	private $_w;
	private $_h;
	private $_margin;
	
	function __construct( $templater, $wpytt, $wpyttOpts, $wpyttCss ) {
		$this->_templater = $templater;
		$this->_wpytt = $wpytt;
		$this->_opts = $wpyttOpts;
		$this->_css = $wpyttCss;
		//$this->_colors = array( 'lundi' => '1 0 0', 'mardi' => '0 1 0', 'mercredi' => '0 0 1', 'jeudi' => '1 1 0'		);
		$this->_paperSize = 'A5';
		$paperSize = $this->_paperSizes[$this->_paperSize];
		$this->_w = $paperSize[1];
		$this->_h = $paperSize[0];
		$this->_margin = 5;

	}
	
	function renderHeader() {
		$this->renderInit();
		ob_start();
		$width = $this->_w;
		$height = $this->_h;
	echo "
%!PS-Adobe-2.0 EPSF-2.0
%%BoundingBox: 0 0 {$width} {$height}
/inch {72 mul} def      % Convert inches->points (1/72 inch)
/Helvetica findfont 12 scalefont setfont %use 12 pt Helvetica font
% PROCEDURE draw-box
/draw-box {
/b exch def
/g exch def
/r exch def
/h exch def
/w exch def
/y exch def
/x exch def
newpath
x y moveto
w 0 rlineto
0 h rlineto
w neg 0 rlineto
closepath
r g b setrgbcolor %rgb
} def
";
	}

	function renderFooter() {
	echo "
1 0 0 setrgbcolor %red
(EPS output done !)		show
showpage                % We're done... eject the page	
";
$data = ob_get_contents();
ob_end_clean();
$fh = fopen("out.eps", "w+");
if( !$fh ) die( 'file open failed !' );
$n = fwrite( $fh, $data );
if( !$n ) die( 'write failed !' );
	}
	
	/* Get the hours "head" column */
	function renderHeadColumn() {

		$hmin = $this->_opts['heure_mini'] / 60;
		$hmax = $this->_opts['heure_maxi'] / 60;
		$span = $hmax - $hmin;

		$idx_int = 0;
		
		$w = $this->_css['head_width'];
		$m = $this->_margin;
		
		$column = "$m $m translate
$w 360 0 0 1 draw-box
stroke";

		for( $i = 0 ; $i < $span ; $i++ ) {
			$intervalle = $this->_intervals[$idx_int];
			if( $i == $intervalle['debut'] ) {
				$sep =  ' vsep';
				$heure = $intervalle['debut'] . '-' . $intervalle['fin'] + $hmin;
				$idx_int++;
				$i += $intervalle['duree'] - 1;
			}
			else {
				$sep = '';
				$heure = $i + $hmin;
			}
			$column .= "$w 15 0 0 0 draw-box
stroke";
			//$column .= "\t--><div class='vhour{$sep}'>&nbsp;$heure</div><!--\n";
		}

		//$hours_column .= "--></div>\n";
		echo $hours_column;
	
	
/*"
2 inch 2 inch translate
36 36 0 0 1 draw-box
fill
gsave
-1 inch -1 inch translate
36 36 0 1 0 draw-box
stroke
grestore
1 inch -1 inch translate
36 36 1 0 0 draw-box
stroke
"	
	echo "
newpath                 % Start a new path
1 inch 1 inch moveto    % an inch in from the lower left
2 inch 1 inch lineto    % bottom side
2 inch 2 inch lineto    % right side
1 inch 2 inch lineto    % top side
20 setlinewidth         % fat line 20 pts wide
closepath               % Automatically add left side to close path
stroke                  % nothing is drawn until you stroke the path!
";*/
	}

	function renderColumn( $day ) {
	if( !isset( $this->_colors[$day] ) ) return;
	$color = $this->_colors[$day];
	$offset1 = strval($this->_i * 1.5);
	$offset2 = strval($this->_i * 2.0);
	$this->_i++;
	//die( strval( $offset ) );
	echo "newpath
$offset1 inch $offset2 inch moveto %move to new point to start new object   
1 inch  .1 inch rlineto % bottom side using relative movement 
-.1 inch 1 inch rlineto % right side
-1 inch -.1 inch rlineto        % top side
closepath               % Automatically add left side to close path
gsave                   % Save the above path, for later reuse  
.5 .2 0 setrgbcolor     % change the color to brown
fill                    % Fill in the box 
grestore                % restore the previous path, to reuse it
$color setrgbcolor % $color
10 setlinewidth         % 10 pts wide
stroke                  %draw the perimeter of the box
1 inch 1 inch moveto
52 rotate
";
	}

	function renderInit() {
		/* Get intervals */
		list( $intervals, $breakHours, $mask, $bph ) = $this->_templater->computeGaps();
		$this->_intervals = $intervals;
		$this->_breakHours = $breakHours;
		$this->_intervalsMask = $mask;
		$this->_bitsPerHour = $bph;
	}

}
?>