<?php
/**
 * 
 * Table renderer interface
 * @author Benoit
 *
 */
abstract class WP_YogaTimeTable_Renderer {

	protected $_templater;
	protected $_days;

	abstract public function renderHeader();
	abstract public function renderFooter();
	abstract public function renderHeadColumn();
	abstract public function renderColumn( $day );

	public function render( $echo = true ) {
	
		/* Initialization */
		if( method_exists( $this, 'renderInit' ) )
			$this->renderInit();

		/* Get active days */
		$this->_days = $this->_templater->getDays();

		/* Timetable wrapper div open */
		$out .= $this->renderHeader();

		/* Table 1st column : hours */
		$out .= $this->renderHeadColumn();

		foreach( array_keys( $this->_days ) as $dayCode ) {
			$out .= $this->renderColumn( $dayCode );
		}
		
		/* Timetable wrapper div close */
		$out .= $this->renderFooter();
		
		if( !$echo ) return $out;
		echo $out;
	}
	
}
?>