<?php
/*
Template Name: Planning des cours
 get_header(); ?>

<div class="container_main">
<div class="contents_main">

<?php
*/
add_filter( 'the_content', 'wpytt_filter_post' );
global $profs_masks, $nivs_masks;

function wpytt_filter_post( $content ) {

	/* Preg match setup */
	$matches = array();
	$ids = array();
	$table_id = 0; // Also set $table_post in future versions ?
	$pattern_to_replace = array();
	
	/* Case 1 : LEFT FOR FUTURE USE : we may have several tables in the future, managed by custom posts */
	if( preg_match( '/\[timetable id=(\d)+\]/', $content, $matches ) == 1 ) {
		// An ID was specified, then let's retrieve it
		preg_match( '/(\d)+/', $matches[0], $ids );
		$table_id = $ids[0];
		// Then get Custom post ---- WARNING !! This won't be a standard WP post but a CUSTOM post
		$table_post = get_post( $table_id );

		$pattern_to_replace[] = '/\[timetable id=(\d)+\]/';
	}
	/* Case 2 : we only have ONE timetable containing all the (yoga) classes */
	else if( preg_match( '/\[timetable]/', $content, $matches ) == 1 )
		$pattern_to_replace[] = '/\[timetable]/';
	
	$replacement_string = "<div style='margin-left: -120px; width: 80%;'>" 
		. wpytt_generate_table_controls() . wpytt_generate_timetable() . "</div>";
	//$replacement_string = wpytt_generate_table_controls() . wpytt_generate_timetable();
	$replacement_a = array( $replacement_string ); 

	return( preg_replace($pattern_to_replace, $replacement_a, $content) ); 
}

/* Get the timetable JS controls */
function wpytt_generate_table_controls() {

	global $profs_masks, $nivs_masks;

	$table_controls = "\n\n<div style='padding: 4px; font-size: 11px;'>\n<table>\n<tr>\n  <td>Professeurs&nbsp;:</td>\n";
	
	$profs_masks = array();
	$width_profs = array( '133', '127', '155', '147', '138' );
	$idx_w = 0;
	$les_profs = get_posts( array( 'post_type' => 'les-professeurs', 'numberposts' => -1, 'post_status' => 'publish', 'exclude' => '361', 'orderby' => 'menu_order', 'order' => 'ASC' ) );
	$bitmask_position = 0;
	$prof_bitmask_all = 0;
	
	//DBG
	$dbg_prof_masks = array();
	
	foreach( $les_profs as $prof ) {
		$prof_name = $prof->post_name;
		 //DBG START
		$prof_title = $prof->post_title;
		$title_bits = explode( ' ', $prof_title );
		$title_short = "";
		foreach( $title_bits as $bit ) $title_short .= $bit[0];
		 //DBG END
		$mask = 1 << $bitmask_position;
		$profs_masks[$prof_name] = $mask;
		$prof_bitmask_all += $mask;
		$dbg_prof_masks[$prof_name] = $title_short . ':' . $mask; //DBG
		$bitmask_position++;
		$table_controls .= "  <td class='_$prof_name' style='width: ".$width_profs[$idx_w]."px;'>\n    <input class='cbprof' type='checkbox' id='$prof_name' name='$prof_name' value='$mask' checked>"
			.$prof->post_title."</input>\n  </td>\n";
		$idx_w++;
		}

	$niv_style = 'padding: 1px 20px 1px 5px; text-align: left;';
	$table_controls .=  "\n</tr>\n</table>\n".
		"<input type='hidden' name='pmask' value='$prof_bitmask_all' />\n" .
		"\n<table>\n<tr>\n  <td style='width: 71px;'>Niveaux&nbsp;:</td>\n";
	$niv_masks = array();
	$niveaux = wpytt_get_niveaux_kva('');
	$bitmask_position = 0;
	$niv_bitmask_all = 0;
	//DBG
	$dbg_niv_masks = array();
	$dbg_niv_slugs = array();
	
	foreach( $niveaux as $slug => $name ) {
		$mask = 1 << $bitmask_position;
		$nivs_masks[$slug] = $mask;
		
		//DBG
		$dbg_niv_masks[$slug] = $name . ':' . $mask; 
		$dbg_niv_slugs[$slug] = $name . ':' . $slug; 
		
		$niv_bitmask_all += $mask;
		$bitmask_position++;
		$table_controls .= "  <td><div class='_$slug tabcontniv'><input class='cbniveau' type='checkbox' id='$slug' name='$slug' value='$mask' checked>$name</input></div></td>\n";
	}
	$dbg_prof_masks_str = implode( ' ', $dbg_prof_masks ) ;
	$dbg_niv_masks_str = implode( ' ', $dbg_niv_masks ) ;
	$dbg_niv_slugs_str = implode( ' ', $dbg_niv_slugs ) ;
	$ajax_url = plugins_url('ajaxFrame-debug.php', __FILE__);
	$table_controls .= "</tr>\n</table>\n\n</div>\n" .
		"<input type='hidden' id='dbg_prof_masks' name='dbg_prof_masks' value='$dbg_prof_masks_str' />\n" .
		"<input type='hidden' id='dbg_niv_masks' name='dbg_niv_masks' value='$dbg_niv_masks_str' />\n" .
		"<input type='hidden' id='dbg_niv_slugs' name='dbg_niv_slugs' value='$dbg_niv_slugs_str' />\n" .
		"<input type='hidden' id='ajaxUrl' value='$ajax_url' />\n" .
		"<input type='hidden' name='nmask' value='$niv_bitmask_all' />\n\n";
		
	$debug_div = "<div style='position: absolute; left: 780px; width: 460px; height: 780px; '>" .
		"<iframe id='ifr' width='460' height='500' frameborder='0' scrolling='auto' style='border: 1px solid #ccc' src='$ajax_url'>" .
		"</iframe>" .
		"<textarea  id='debug' rows='15' cols='68' style='font-family: Arial; font-size: small'></textarea>" .
		"<input type='button' value='Reset' id='dbgReset' /></div>";
	return $debug_div . $table_controls;
	//return $table_controls; // . "<br>" . serialize( $profs_masks ) . "<br>" . serialize( $nivs_masks ) . "<br>";
}
/* End wpytt_generate_table_controls */

/* Get the days that are enabled (in the current version of plugins, all days from Mon to Sat are) */
function wpytt_get_active_days() {
	return array( 'lundi' => 'Lundi', 'mardi' => 'Mardi', 'mercredi' => 'Mercredi', 
		'jeudi' => 'Jeudi', 'vendredi' => 'Vendredi', 'samedi' => 'Samedi' );
}

/* Get the hours "head" column */
function wpytt_get_hours_column( $hmin, $hmax, $intervalles ) {

	$idx_int = 0;
	
	$hours_column = "<div class='vday vday_narrow'><!--\n" .
		"\t--><div class='vyclass colhead'>Heure</div><!--\n";

	for( $i = $hmin ; $i < $hmax ; $i++ ) {
		$intervalle = $intervalles[$idx_int];
		if( $i == $intervalle['debut'] ) {
			$sep =  ' vsep';
			$heure = $intervalle['debut'] . '-' . $intervalle['fin'];
			$idx_int++;
			$i += $intervalle['duree'] - 1;
		}
		else {
			$sep = '';
			$heure = $i;
		}
		$hours_column .= "\t--><div class='vhour{$sep}'>&nbsp;$heure</div><!--\n";
		}

	$hours_column .= "--></div>\n";
	return $hours_column;
}
/* END wpytt_get_hours_column */

/* Generate the timetable */
function wpytt_generate_timetable() {
	/* Get plugin options */
	global $wpytt_options, $wpdb;
	global $profs_masks, $nivs_masks;
	$wpytt_options = get_option( 'wpytt_options');

	/* Get active days */
	$jours = wpytt_get_active_days() ;

	/* Timetable wrapper div */
	$timetable = '<div class="vtt-box">';

	/* Get "professeurs" from DB */
	$sql_profs = "SELECT post_name,ID,post_title FROM {$wpdb->posts} WHERE post_type = 'les-professeurs'";
	$profs = $wpdb->get_results( $sql_profs, OBJECT_K );
	$professeurs = array();
	foreach( $profs as $slug => $data )
		$professeurs[$slug] = $data->post_title;
	
	$is_logged = is_user_logged_in();
	$titre_append = ( $is_logged ) ? "</a>" : "";

	$cssvars = $wpytt_options['css'];
	$heure_h = $cssvars['heure_h'];
	$sep_h = $cssvars['sep_h'];

	/* Table 1st column : hours */
	$hmin = $wpytt_options['heure_minimale'];
	$hmax = $wpytt_options['heure_maximale'];
	$intervalles = $wpytt_options['intervalles'];
	$timetable .= wpytt_get_hours_column( $hmin, $hmax, $intervalles );

	$heure_inf = $hmin * 60;
	$debug_str = "<tr><td>slug_prof</td><td>slug_jour</td><td>heure_debut</td><td>heure_fin</td><td>marge_debut</td><td>palier_fin</td></tr>";
	foreach( $jours as $slug_jour => $titre_jour ) :
		$timetable .= "\n\n<div class='vday vday-$slug_jour'><!--\n"
			."--><div class='vyclass colhead'><b>$titre_jour</b></div><!--\n";
		/* Recuperer les cours pour ce jour */
		$cours_query = new WP_Query( "post_type=cours-yoga&post_status=publish&orderby=menu_order&order=ASC&meta_value=$slug_jour" );
		$marge_debut = -1;
		$palier_fin = -1;
		if ( $cours_query->have_posts() ) :
			while( $cours_query->have_posts() ) :
				$cours_query->the_post();
				$titre_prepend =  ( $is_logged ) ? "<a href='" . get_edit_post_link( get_the_ID() ) . "'>" : "";
				$titre_cours = get_the_title();
				$slug_prof = get_post_meta( get_the_ID(), 'professeur', true );
				$prof = $professeurs[$slug_prof];
				$slug_jour = get_post_meta( get_the_ID(), 'jour_semaine', true );
				$heure_debut_num = get_post_meta( get_the_ID(), 'heure_debut', true );
				$heure_debut_pretty = pretty_print_heure( $heure_debut_num );
				$heure_fin_num = get_post_meta( get_the_ID(), 'heure_fin', true );
				$heure_fin_pretty = pretty_print_heure( $heure_fin_num );
				
				$heure_debut_num -= $heure_inf;
				$heure_fin_num -= $heure_inf;
				$duree_num = $heure_fin_num - $heure_debut_num;
				$duree_num_pretty = pretty_print_heure( $duree_num );

				if( $marge_debut < 0 ) $palier_fin = 0;
				//	$marge_debut = $heure_debut_num;
				//else {
					$marge_debut = $heure_debut_num - $palier_fin;
					$int_deb = $palier_fin / 60 + $hmin;
					$int_fin = $heure_debut_num / 60 + $hmin;
					$debug_str .= "$int_deb $int_fin<br>";
					$num_ints = 0; $num_heures_pause = 0;
					foreach( $intervalles as $pause ) {
						if( $pause['debut'] >= $int_deb && $pause['fin'] <= $int_fin ) {
							$num_ints++;
							$num_heures_pause += $pause['duree'] - 1;
						}
					}
					$debug_str .= "$slug_jour " . serialize( $intervalles ) . " $int_deb $int_fin $num_ints<br>";
//					$marge_debut += $num_ints * ( $sep_h - $heure_h );
				//}
				$marge_debut_pretty = pretty_print_heure( $marge_debut );

				$palier_fin = $heure_fin_num;
				$palier_fin_pretty = pretty_print_heure( $palier_fin );
					
				$debug_str .= "<tr style='border-top: 1px solid #778'><td>$slug_prof</td><td>$slug_jour</td><td>$heure_debut_pretty</td><td>$heure_fin_pretty</td><td>$marge_debut";
				$debug_str .= "</td><td>$palier_fin</td></tr>";

				$marge_debut2 = ( ( $marge_debut * $heure_h ) / 60 ) - 1;
				$marge_debut2 += $num_ints * ( $sep_h - $heure_h ) - ( $num_heures_pause * $heure_h );
				$duree_num2 = ( $duree_num * $heure_h ) / 60;

				$debug_str .= "<div style='background: #def;'>[md: $marge_debut | d: $duree_num | {$heure_h}px/h] [$marge_debut2 | $duree_num2]</div>";
				
				$terms_niveaux = get_the_terms( $post->ID, 'niveau-cours' );
				if( !empty( $terms_niveaux ) ) {
					$slugs_niveaux = array();
					$niveaux = array();
					$niv_matches;
					$nivs_mask = 0;
					foreach( $terms_niveaux as $term ) {
						$slugs_niveaux[] = $term->slug;
						preg_match( '/(\d)+/', $term->name, $niv_matches );
						$niv_number = $niv_matches[0];
						$is_numbered = !empty( $niv_number );
						if( $is_numbered )	$niveaux[] = $niv_number;
						else $niveaux[] = $term->name;
						$nivs_mask += $nivs_masks[$term->slug];
						}
					$slugs_str = implode( ' ', $slugs_niveaux );
					$niveaux_str = ( $is_numbered ? 'N' : '' ) . implode( ',', $niveaux );
					$premier_niv_str = ( $is_numbered ? 'N' : '' ) . $niveaux[0];
				}
				$modele = get_post_meta( get_the_ID(), 'modele', true );
				if( empty( $modele ) ) $modele = "standard";
				$modele_custom = get_post_meta( get_the_ID(), 'modele_custom', true );
				if( $modele == "custom" && !empty( $modele_custom ) ) {
					$replacement_strings = array(	'$prof' => $prof, 
													'$niv' => $niveaux_str,
													'$jour' => $titre_jour,
													'$debut' => $heure_debut_pretty,
													'$fin' => $heure_fin_pretty,
													"\n" => "<br>" );
					foreach( $replacement_strings as $str => $replacement )
						$modele_custom = str_replace( $str, $replacement, $modele_custom );
				}
				$modeles = array(
								"standard" => "{$titre_prepend}$niveaux_str : $heure_debut_pretty &mdash; $heure_fin_pretty{$titre_append}<br>$prof",
								"multiple" => "{$titre_prepend}$niveaux_str : d&eacute;but $heure_debut_pretty{$titre_append}<br>$prof<br>$premier_niv_str&nbsp;: fin $heure_fin_pretty",
								"court" => "{$titre_prepend}$niveaux_str : fin $heure_fin_pretty{$titre_append}",
								"custom" => $titre_prepend.$modele_custom.$titre_append );
				
				$has_no_border_top = ( $marge_debut2 == 0 );
				if( $has_no_border_top ) {
					$no_border_top = 'border-top: none; ';
					//$duree_num2 -= 1;
				}
				else {
					$no_border_top = '';
					$duree_num2 -= 1;
				}
				$prof_mask = $profs_masks[$slug_prof];
				$case = "--><div class='vyclass $slug_prof $slugs_str' style='{$no_border_top}margin-top: $marge_debut2"
					  .	"px; height: $duree_num2"."px;' text='$prof_mask|$nivs_mask'><div style='margin-top: 3px'>"
					  . $modeles[$modele]
					  . "</div></div><!--\n";
				$timetable .= $case;
			endwhile;
		endif;
		$timetable .= '--></div>';

	endforeach;
	
	$timetable .= "</div>\n<!-- vtt-box -->\n</div>\n";
	// $timetable .= '<div style="margin: 60px 0 0 80px"><table style="border:1px solid #a44">' . $debug_str . '</table></div>'; // For DEBUGGING only
	
	return $timetable;

}
/* End wpytt_get_template */

?>