<?php
function wpytt_regenerate_css() {

	global $wpytt;
	//global $wpytt_options;
	$css_vars = $wpytt->settings->css ;
	
	/* Get colors */
	$niveauxCouleurs = array_flip( $css_vars['couleurs_niv'] );
	$terms_niveaux = wpytt_get_niveaux( 'DESC' );
	$css = "/* Colors */\n";
	foreach( $terms_niveaux as $term_niveau ) {
		$niveau = $term_niveau->slug;
		$couleur = $niveauxCouleurs[$niveau];
		$css .= "
.$niveau , ._$niveau {
\tbackground: #$couleur;
}
";
	}
	
	/* Open CSS template and fill an array with its lines */
	$thisfile = basename( __FILE__ );
	$thispath = $wpytt->getPath();
	$fh = fopen( $thispath . 'timetables-niv.template.css', 'r' );
	while( $line = fgets( $fh ) ) $css .= $line;
	fclose( $fh );

	foreach( $css_vars as $var => $value ) {

			/* Decrement hours heights */
			if( $var == 'heure_h' || $var == 'sep_h' ) $value -= 1;

			/* Translate font choice  in px */
			if( $var == 'font_size' ) {
				$tailles = get_tailles_police();
				$value = $tailles[$value];
			}
	
			$css = str_replace( "[$var]", $value, $css );
		}

	$lines = explode( "\n", $css );
	$fh = fopen( $thispath . 'timetables-gen.css', 'w+' );
	foreach( $lines as $line ) fputs( $fh, $line );
	fclose( $fh );
}

	global $wpytt;
	//global $wpytt_options;
	$css_vars = !empty( $wpytt->settings->css ) ? $wpytt->settings->css : array();
	
	/* Heures minimale et maximale, granularite */
	if( !empty( $_POST['select_larg_jour'] ) ) $css_vars['jour_w'] = $_POST['select_larg_jour'];
	if( !empty( $_POST['select_haut_heure'] ) ) $css_vars['heure_h'] = $_POST['select_haut_heure'];
	if( !empty( $_POST['select_haut_sep'] ) ) $css_vars['sep_h'] = $_POST['select_haut_sep'];
	$num_pauses = count( $wpytt_options['intervalles'] );
	$css_vars['jour_h'] = ( ( $wpytt->settings->heure_maxi - $wpytt->settings->heure_mini - $wpytt->settings->total_heures_pause ) * $css_vars['heure_h'] ) + ( $num_pauses * $css_vars['sep_h'] ) + 35;
	
	//echo "Debug : ( ( ". $wpytt_options['heure_maximale'] . " - ". $wpytt_options['heure_minimale']." - ".$wpytt_options['total_heures_pause']." ) * ". $css_vars['heure_h']." ) + ( ". $num_pauses ." * " . $css_vars['sep_h'] . " ) + 35 = ".$css_vars['jour_h']."<br>";

	/* Font */
		if( !empty( $_POST['select_font_size'] ) ) $css_vars['font_size'] = $_POST['select_font_size'];

	/* Couleurs */
	$colors = array();
	$couleursNiveaux = array();
	for( $i = 0 ; $i < 16 ; $i++ ) {
		$color_i = $_POST['colorpickerField-'.$i];
		$niv_i = $_POST['coulNivField-'.$i];
		if( !empty( $color_i ) && ($color_i != '#' ) ) { 
			$colors[] = $color_i;
			if( $niv_i != "none" ) $couleursNiveaux[$color_i] = $niv_i;
			}
		}
	$css_vars['couleurs_niv'] = $couleursNiveaux;
	$css_vars['colors'] = $colors;
	
	/*  Injection des variables CSS dans les options globales*/
	$wpytt->settings->css = $css_vars;
	
	//update_option( 'wpytt_options', $wpytt_options );
	$wpytt->settings->update();
	wpytt_regenerate_css();
?>