/******************************************************
 * Utilities...                                       *
 ******************************************************/

 // Debug helper (output field values)
function dbg( kvArr ) {
		var str = 'Champs\n';
		for( k in kvArr ) str +=  'key: ' + k + ', value: ' + kvArr[k] + '\n';
		alert( str );
}

function flatkv( kvArr ) {
		var str = '<br><b>Champs</b><br>';
		for( k in kvArr ) 
			if( kvArr[k] != undefined ) str +=  'key: ' + k + ', value: ' + kvArr[k] + '<br>';
		return str;
}

function flatkvs( kvArr ) {
		var str = '<br><b>Champs</b><br>';
		for( k in kvArr ) 
			if( kvArr[k] != undefined ) str +=  'key: ' + k + ', value: ' + serialize( kvArr[k] )+ '<br>';
		return str;
}

var idx = 0;

function mdiv( message, type ) {
	$( '#messages' ).html( message ).fadeIn( 'slow' ).attr( 'class', type );
	$( '#message_lt' ).val( '2' );
}

//function mowner( e ) {
//	ddiv( '#msgb', $( '#message_lt' ).val() );
//	return ( e == $( '#message_owner' ).val() ) ;
//}

function mclear() {
	//ddiv( '#msgb', $( '#message_lt' ).val() , 'views' );
	newv = $( '#message_lt' ).val() - 1;
	$( '#message_lt' ).val(newv);
	if( newv == 0 ) $( '#messages' ).html('').fadeOut( 'slow' ).attr( 'class', 'hidden' );
	//ddiv( '#msgc', $( '#message_lt' ).val() , 'actions' );
}

function ddiv( target, message, type, wipe, wrap ) {
	message = idx + ' [' + type + '] ' +message;
	idx++;
	if( wrap != undefined && wrap == true ) {
		tagOpen = '<span>'; tagClose = '</span>';
	}
	else {
		tagOpen = ''; tagClose = '<br>';
	}
	if( wipe != undefined && wipe == false )
		$( target ).append( tagOpen + message + tagClose ).fadeIn( 'slow' ).attr( 'class', type );
	else
		$( target ).html( tagOpen + message + tagClose ).fadeIn( 'slow' ).attr( 'class', type );
}

function zdiv( target ) {
	$( target ).html( '' ).fadeOut( 'slow' ).attr( 'class', 'hidden' );
}

function kvdiv( target, kvArr ) {
	str = "<table style='border: 1px solid #ddd; display: inline-table; margin: 3px;'>";
	for( prop in kvArr ) {
		str += "<tr><td>" + prop + "</td><td>" + kvArr[prop] + "</td></tr>" ;
	}
	str += "</table>";
	ddiv('#debug_' + target, str, target, false, false );
}

function getNameAttr( elem ) {
	return elem.target.attributes.getNamedItem("name").value;
}

function hasObj( arr, obj ) {
    return ( arr.indexOf( obj ) != -1 );
}

var getValueByFieldType = { 
	'text' : function( elem ) { return elem.value; },
	'select' : function( elem ) { return $( 'select[name=' + elem.name + '] option:selected' ).val(); },
	'checkbox' : function( elem ) { return $(elem).is(':checked'); },
	'radio' : function( elem ) { return $( 'input[name=' + elem.name + ']:checked' ).val(); 
/*		var value = null;
		$( 'input[name=' + elem.name + ']' ).each( function() {
			if( $(this).is(':checked') ) value = this.value; } );
		return value;*/
	}
};
function getFieldType( elem ) { 
	var nodeName = elem.nodeName.toLowerCase();
	var fieldType = elem.type;
	var fieldValue = elem.value;
	var type = 'text';
	if( nodeName == 'select' ) type = 'select';
	if( ( nodeName == 'input' ) && ( fieldType == 'radio' || fieldType == 'checkbox' ) )
		type = fieldType;
	return type;
}


/******************************************************
 * Simple class for implementing the Observer pattern *
 ******************************************************/
var Event = function (sender) {
    this._sender = sender;
    this._listeners = [];
};
 
Event.prototype = {
    attach : function (listener) {
        this._listeners.push(listener);
    },
    notify : function (args) {
        for (var i = 0; i < this._listeners.length; i++) {
			$('#debug_notifs').html( this._sender );
            this._listeners[i](this._sender, args);
        }
    }
};


/********************************************
 * Ical-style parser functions              *
 ********************************************/
var RecurrenceParser = function(  ) {
	
}


RecurrenceParser.prototype = {

	build : function( fields ) {

		// Recurrence rule root
		var rRule = 'RRULE:';
		var rRuleBits = [];
		
		var rules = {
			'FREQ':		  '',	'INTERVAL':	  '',
			'COUNT':	  '',	'UNTIL': 	  '',
			'BYDAY':	  '',	'BYMONTHDAY': ''
		};

		if( fields['BYDAY'] == '' ) {
			byDays = [];
			days = [ 'SU', 'MO', 'TU', 'WE', 'TH', 'FR', 'SA' ];
			for( var d = 0 ; d < days.length ; d++ ) 
				if( fields[days[d]] ) byDays.push( days[d] );
			rules['BYDAY'] = byDays.join( ',' );
		}
		else rules['BYDAY'] = fields['BYDAY'];
		//ddiv( '#msgb', 'BYDAY :' + rules['BYDAY'] + '<br>', 'models');

		rules['BYMONTHDAY'] = fields['BYMONTHDAY'];

		// Frequency is ALWAYS set
		// Check "standard" cases : daily, weekly, etc.
		var freq = fields['FREQ'];
		freqs = [ 'DAILY', 'WEEKLY', 'MONTHLY', 'YEARLY' ];
		for( var i = 0; i < freqs.length; i++ )
			if ( freqs[i] == freq ) rules['FREQ'] = freq ;
		// If none of them, this must be one of predefined MO-TU-....
		//ddiv( '#msgc', 'FREQ before overwrite :' + rules['FREQ'], 'models');
		// So we overwrite BYDAY
		if( rules['FREQ'] == '' ) {
			rules['BYDAY'] = freq.split( '-' ).join( ',' );
			rules['FREQ'] = 'WEEKLY';
		}

		// INTERVAL taken if account if field set and > 1
		rules['INTERVAL'] = ( parseInt( fields['INTERVAL'] ) > 1 ) ? fields['INTERVAL'] : '';
		rules['COUNT'] = fields['COUNT'];
		if( fields['UNTIL'] != '' ) {
			if( fields['wholeday'] ) rules['UNTIL'] = getDateIcalFromRegional( fields['UNTIL'] );
			else rules['UNTIL'] = getDateTimeIcalUTCFromRegional( [ fields['UNTIL'], fields['endtime'] ] );
		}
		
		for( field in rules )
			if( rules[field] != '' )
				rRuleBits.push( field + '=' + rules[field] );
		rRule += rRuleBits.join( ';' );
		
		return rRule;
	},
	
	parse : function( regex, string ) {

		// init regex, string array, pop last (empty line)
		var re = new RegExp( regex );
		var	re2 = new RegExp( '[0-9]{1}[A-Z]{2}' );
		var strings = string.split( '\n' );
		strings.pop();
		// init matches and mariables arrays
		//var allMatches = new Array();
		var variables = new Array();
		var dateTime;
		
		variables['recurrent'] = true;
		variables['stopwhentype'] = '_NEVER_';
		for( var i = 0 ; i < 3 ; i++ ) { // replaced strings.length by 3

			var matches = re.exec( strings[i] );
			if ( matches != null ) {
				keyVal = matches[0].toString().split( ':' );
				key = keyVal[0];
				val = keyVal[1];
				//alert( 'Boucle externe:\n' + key + ' ' + val );
				
				switch( i ) {
					case 0 :
						dateTime = getDateTimeRegionalFromIcal( val );
						variables['startdate'] = dateTime[0];
						variables['starttime'] = dateTime[1];
						//alert( 'STD: ' + variables['STARTDATE'] + ', STT: ' + variables['STARTTIME'] );
						break;
					
					case 1 :
						dateTime = getDateTimeRegionalFromIcal( val );
						variables['enddate'] = dateTime[0];
						variables['endtime'] = dateTime[1];
						//alert( 'ENDD: ' + variables['ENDDATE'] + ', ENDT: ' + variables['ENDTIME'] );
						break;
					
					case 2 :
						recurrenceBits = val.split( ';' );
						for( var j = 0 ; j < recurrenceBits.length ; j++ ) {
							kv = recurrenceBits[j].split( '=' );
							k = kv[0];
							v = kv[1];
							//alert( 'Boucle interne:\n' + k + ' ' + v );
							switch( k ) {
								case 'FREQ' :
								case 'INTERVAL' :
									variables[k] = v;
									break;
								case 'COUNT' :
									variables['stopwhentype'] = k;
									variables[k] = v;
									break;
								case 'UNTIL' :
									variables['stopwhentype'] = k;
									variables[k] = (getDateTimeRegionalFromIcalUTC( v ))[0];
									break;
								case 'BYMONTHDAY' :
									variables['repeatmonthtype'] = k;
									variables[k] = v;
									break;
								case 'BYDAY' :
									var nthDays = re2.exec( v );
									
									if( nthDays != null ) {
										variables['repeatmonthtype'] = 'BYDAY';
										variables[k] = v;
									}
									else {
										var days = v.split( ',' );
										if( v == 'MO,TU,WE,TH,FR' || v == 'MO,WE,FR' || v == 'TU,TH' ) variables['FREQ'] = days.join( '-' );
										for( d in days )
											variables[days[d]] = true;
									}
									break;
							}
						}
					}
			}
		}
		return variables;
	}

};

/*************************************************************
 * RecurrenceFormMapper : mapper champs recurrence vers form *
 *************************************************************/
var RecurrenceFormMapper = function(  ) {

	this.recurrenceToForm = function ( recurrence, formElements ) {
		recParser = new RecurrenceParser( );
		var recArray = recParser.parse( '^[A-Z]*.*', recurrence );
		
	}

}

RecurrenceFormMapper.prototype = {

	parse : function( regex, string ) {
		// init regex and string array
		var re = new RegExp( regex );
		var strings = string.split( '\n' );
		strings.pop();
		var allMatches = new Array();
		var log = "";
		
		for( var i = 0 ; i < strings.length ; i++ ) {
			var matches = re.exec( strings[i] );
			if ( matches != null )
				allMatches.push( matches );
		}
		if( allMatches.length == 0 )
			alert("No match");
		else {
			var json_head = '\'{ "recurrences": [\'\n';
			var json_tail = '+ \']}\'';
			var json_body = new Array();
			for( var j = 0 ; j < allMatches.length ; j++ ) {
				keyVal = allMatches[j].toString().split( ':' );
				key = keyVal[0];
				val = keyVal[1];
				$('#recTable').append( '<tr><td>' + j + '</td><td>' + key + '</td><td>' + val + '</td></tr>' ); 
				json_body.push( '\t+ \'{"index": "' + j + '", "key": "' + key + '", "val": "' + val + '"},\'' );
				
				log += j + '-\t' + allMatches[j] + "\n";
			}
			$('#recJSON').val( json_head + json_body.join( '\n' ) + json_tail );
			//alert( log );
		}
	}

};

/******************************************************
 * Date utility functions                             *
 ******************************************************/

var DateModel = function( dateJs, dateFormat, firstDay ) {
	this._dateFormat = ( dateFormat != null ) ? dateFormat : "dd/mm/yy";
	this._firstDay = (firstDay != null ) ? firstDay : 1;
	this.setDates( dateJs );
}	

DateModel.prototype = {

	setDates : function( dateJs ) {
		this._dateJs = dateJs;
		this._dateIso = getDateIsoFromJs( this._dateJs );
		this._dateRegional = getDateRegionalFromIso( this._dateIso );
	},
	
	setDateIso : function( dateIso ) {
		this._dateIso = dateIso;
		this._dateJs = getDateJsFromIso( this._dateIso );
		this._dateRegional = getDateRegionalFromIso( this._dateIso );
	},
	
	
	/*** GETTERS ***/
	getJs : function() {
		return this._dateJs;
	},

	getIso : function() {
		return this._dateIso;
	},

	getRegional : function() {
		return this._dateIso;
	},

	getFullString : function() {
		return "js: " + this._dateJs + ", iso: " + this._dateIso + "regional: " + this._dateRegional;
	},

	toString : function() {
		return this.getDatePretty();
	},

	// returns day of the week with Mon = 0, Sun = 6 (because getDay() returns 0 for Sun and 6 for Sat)
	// d is a standard js Date object
	getDayofweek : function( date ) {
		var day;
		var offset = 7 - this._firstDay;
		if( date != undefined ) var day = date.getDay();
		else day = this._dateJs.getDay();
		day += offset // day += 6;
		var dmod = day % 7;
		return dmod;
	},

	// returns printable day name
	getDayofweekPretty : function( args ) {
		isShort = ( 'short' in args ) ? args['short'] : false;
		date = ( 'date' in args ) ? args['date'] : this._dateJs;
		if( false )
		//if( !isShort )
			days = new Array( 'Lundi', 'Mardi', 'Mercredi', 'Jeudi', 'Vendredi', 'Samedi', 'Dimanche' );
		else
			days = new Array( 'Lun', 'Mar', 'Mer', 'Jeu', 'Ven', 'Sam', 'Dim' );
		dmod = this.getDayofweek( date );
		return days[dmod];
	},

	getYear : function( args ) {
		return this._dateJs.getFullYear();
	},
	
	// gets printable month name
	getMonthPretty : function( month ) {
		if( month == undefined ) month = this._dateJs.getMonth();
	//	months = new Array( 'Janvier', 'Février', 'Mars', 'Avril', 'Mai', 'Juin',
	//		'Juillet', 'Août', 'Septembre', 'Octobre', 'Novembre', 'Décembre' );
		months = new Array( 'Jan', 'Fév', 'Mars', 'Avr', 'Mai', 'Juil', 'Juil', 'Août', 'Sept.', 'Oct', 'Nov', 'Déc' );
		return months[month];
	},

	getDatePretty : function( date ) {
		//date = ( 'date' in args ) ? args['date'] : this._dateJs;
		if( date == undefined ) date = this._dateJs;
		month = date.getMonth();
		var dotwPretty = this.getDayofweekPretty( { 'date' : date, 'short' : false } );
		return( dotwPretty + ' ' + date.getDate() + ' ' + this.getMonthPretty( month ) + ' ' + date.getFullYear() );
	},

	getWeekInterval : function ( isForGC ) {
		var msecPerDay = 24 * 60 * 60 * 1000;
		var msecPerWeek = 7 * msecPerDay;
		//var dateJs = getDateJsFromIso( dateIso );
		//var dotw = getDayofweek( dateJs );
		dotw = this.getDayofweek();
		var max;
		if( isForGC )
			max = 7 - dotw;
		else
			max = 6 - dotw;
		
		var firstDate = new Date( this._dateJs.getTime() - ( dotw * msecPerDay ) );
		var lastDate = new Date( this._dateJs.getTime() + ( max * msecPerDay ) );
		return new Array( firstDate, lastDate );
	},
	
	getWeekIntervalGC : function() {
		dates = this.getWeekInterval( true );
		return new Array( getDateIsoFromJs( dates[0] ), getDateIsoFromJs( dates[1] ) );
	},
	
	getWeekIntervalPretty : function() {
		dates = this.getWeekInterval( false );
		return( this.getDatePretty( dates[0] ) + ' - ' + this.getDatePretty( dates[1] ) );
	},
	

	getMonthInterval : function() {
		var dateBits = this._dateIso.split( '-' );
		minYear= dateBits[0];
		minMonth = dateBits[1];
		
		var maxMonth = parseInt( minMonth ) + 1 ;
		if( maxMonth > 12 ) {
			maxYear = parseInt( minYear ) + 1;
			maxMonth = 1;
		}
		else maxYear = minYear;
		
		minMonth = '' + minMonth;
		maxMonth = '' + maxMonth;
		if( minMonth.length == 1 ) minMonth = '0' + minMonth;
		if( maxMonth.length == 1 ) maxMonth = '0' + maxMonth;
		min = minYear + '-' + minMonth + '-01';
		max = maxYear + '-' + maxMonth + '-01';
		return new Array( min, max );
	},
	
	getMonthAndYear : function(){
		return( this.getMonthPretty() + " " + this.getYear() );
	}

	/*function getWeekIntervalPrettyFromRegional( dateRegional ) {
		dateIso = getDateIsoFromRegional( dateRegional );
		weekInterval = getWeekInterval( dateIso, false );
		dayStart = weekInterval[0];
		dayEnd = weekInterval[1];
		return( dayStart + ' - ' + dayEnd );
	}*/


};
/*** END DateModel prototype ***/



/*** UTILITY DATE FUNCTIONS ***/

// returns day of the week with Mon = 0, Sun = 6 (because getDay() returns 0 for Sun and 6 for Sat)
// d is a standard js Date object
function getDayofweek( dateJs ) {
		var day;
		var offset = 6; // 7 - d, with d = 1 for monday in France
		day = dateJs.getDay();
		day += offset // day += 6;
		var dmod = day % 7;
		return dmod;
}

function getDayofmonth( dateRegional ) {
	dateBits = dateRegional.split( '/' );
	dateJs = getJsDate( dateBits[2], dateBits[1], dateBits[0] );
	idxDayOfWeek = getDayofweek( dateJs );
	days = [ 'MO', 'TU', 'WE', 'TH', 'FR', 'SA', 'SU' ];
	dayOfWeek = days[idxDayOfWeek];
	nthOfMonth = parseInt( ( parseInt( dateBits[0] ) + 6 ) / 7 );
	return nthOfMonth + dayOfWeek;
}


/* ICAL <=> REGIONAL */

// convert from YYYYMMDD to JJ/MM/AAAA
function getDateRegionalFromIcal( dateIcal ) {
	var year = dateIcal.substring( 0, 4 );
	var month = dateIcal.substring( 4, 6 );
	var day = dateIcal.substring( 6 );
	return day + '/' + month + '/' + year;
}

// convert from JJ/MM/AAAA to YYYYMMDD
function getDateIcalFromRegional( dateRegional ) {
	var dateBits = dateRegional.split( '/' );
	return (dateBits.reverse()).join( '' );
}

// convert time from HHMMSS to HH:MM
function getTimeRegionalFromIcal( timeIcal ) {
	var hour = timeIcal.substring( 0, 2 );
	var minutes = timeIcal.substring( 2, 4 );
	return hour + ':' + minutes;
}

// convert from HH:MM to HHMMSS
function getTimeIcalFromRegional( timeRegional ) {
	var timeBits = timeRegional.split( ':' );
	hour = timeBits[0];
	minutes = timeBits[1];
	return timeStripped + '00';
}

// convert dateTime from YYYYMMDDTHHMMSS to regional
function getDateTimeRegionalFromIcal( dateTimeIcal ) {
	var dateTimeBits = dateTimeIcal.split( 'T' );
	var dateTimeRegional = new Array(2);
	dateTimeRegional[0] = getDateRegionalFromIcal( dateTimeBits[0] );
	dateTimeRegional[1] = ( dateTimeBits.length > 1) ? getTimeRegionalFromIcal( dateTimeBits[1] ) : '';
	return dateTimeRegional;
}
// convert dateTime from regional to YYYYMMDDTHHMMSS
function getDateTimeIcalFromRegional( dateTimeRegional ) {
	return getDateIcalFromRegional( dateTimeRegional[0] )
		+ ( dateTimeRegional.length > 1 ) ? 'T' + getTimeIcalFromRegional( dateTimeRegional[1] ) : '';
}

// convert dateTime from YYYYMMDDTHHMMSS to regional
function getDateTimeRegionalFromIcalUTC( dateTimeIcalUTC ) {

	var dateTimeBits = dateTimeIcalUTC.split( 'T' );
	if( dateTimeBits.length == 1 ) return getDateRegionalFromIcal( dateTimeBits[0] );

	var dateUTC = dateTimeBits[0];
	var year = dateUTC.substring( 0, 4 );
	var month = parseInt( dateUTC.substring( 4, 6 ) ) - 1;
	var day = dateUTC.substring( 6 );

	var timeUTC = dateTimeBits[1];
	var hour = timeUTC.substring( 0, 2 );
	var minutes = timeUTC.substring( 2, 4 );

	var dateJs = new Date();
	dateJs.setUTCDate( day ); dateJs.setUTCMonth( month ); dateJs.setUTCFullYear( year );
	dateJs.setUTCHours( hour ); dateJs.setUTCMinutes( minutes );
	
	return getDateTimeRegionalFromJs( dateJs );
}
// convert dateTime from regional to YYYYMMDDTHHMMSS
function getDateTimeIcalUTCFromRegional( dateTimeRegional ) {
	var dateJs = getDateTimeJsFromRegional( dateTimeRegional );
	
	var yearUTC = '' + dateJs.getUTCFullYear();
	var monthUTC = '' + ( dateJs.getUTCMonth() + 1 );
	var dayUTC = '' + dateJs.getUTCDate();
	var dateUTC = yearUTC + monthUTC + dayUTC;
	
	var hoursUTC = '' + dateJs.getUTCHours();
	var minutesUTC = '' + dateJs.getUTCMinutes();
	var timeUTC = hoursUTC + minutesUTC + '00Z';
	
	return dateUTC + 'T' + timeUTC;
}

// convert dateTime from YYYYMMDDTHHMMSS to regional
function getDateTimeRegionalFromGdataWhen( dateTimeGdata ) {

	var dateTimeBits = dateTimeGdata.split( 'T' );
	dateTimeRegional = new Array( 2 );
	dateIso = dateTimeBits[0] ;
	dateRegional = getDateRegionalFromIso( dateIso );
	dateTimeRegional[0] = dateRegional
	dateTimeRegional[1] = '';
	if( dateTimeBits.length > 1 ) {
		var time = dateTimeBits[1].split( ':' );
		var hour = time[0];
		var minutes = time[1];
		dateTimeRegional[1] = hour + ':' + minutes;
	}
	return dateTimeRegional;
}

function timeBitToString( timeBit ) {
	var timeString = '' + timeBit;
	if( timeString.length == 1 ) timeString = '0' + timeString;
	return timeString;
}

// convert dateTime from regional to YYYYMMDDTHHMMSS
function getDateTimeGdataWhenFromRegional( dateTimeRegional ) {
	var dateJs = getDateTimeJsFromRegional( dateTimeRegional );
	var gmtHours = -dateJs.getTimezoneOffset() / 60;
	var gmtString = getFormattedGmtString( gmtHours );
	
	var dateIso = getDateIsoFromJs( dateJs );
	var hours = timeBitToString( dateJs.getHours() );
	var minutes = timeBitToString( dateJs.getMinutes() );
	var seconds = timeBitToString( dateJs.getSeconds() );
	var timeIso = hours + ':' + minutes + ':' + seconds + '000' + gmtString;
		
	return dateIso + 'T' + timeIso;
}

function getFormattedGmtString( gmtOffset ) {
	var negative = ( gmtOffset < 0 );
	gmtOffset = negative ? -gmtOffset : gmtOffset;
	gmtString = timeBitToString( gmtOffset ) + ':00';
	gmtString = (negative) ? '-' + gmtString : '+' + gmtString;
	return gmtString;
}


/* OTHER DATE CONVERSIONS */

/* ISO <=> REGIONAL */

// convert from JJ/MM/AAAA to YYYY-MM-DD
function getDateIsoFromRegional( dateRegional ) {
	var dateBits = dateRegional.split( '/' );
	return (dateBits.reverse()).join( '-' );
}

// convert from YYYY-MM-DD to JJ/MM/AAAA
function getDateRegionalFromIso( dateIso ) {
	var dateBits = dateIso.split( '-' );
	return (dateBits.reverse()).join( '/' );
}

// returns date time in regional format
function getDateTimeRegionalFromJs( d ) {

	dMonth = '' + (d.getMonth() + 1);
	if( dMonth.length == 1 ) dMonth = '0' + dMonth;
	dDay = '' + d.getDate();
	if( dDay.length == 1 ) dDay = '0' + dDay;
	dMonth = '' + (d.getMonth() + 1);
	var dateBits = new Array( dDay, dMonth, d.getFullYear() );
	var dateString = dateBits.join( '/' );

	dHours = '' + d.getHours();
	if( dHours.length == 1 ) dHours = '0' + dHours;
	dMinutes = '' + d.getMinutes();
	if( dMinutes.length == 1 ) dMinutes = '0' + dMinutes;
	var timeString = dHours + ':' + dMinutes;
	
	return new Array( dateString, timeString);
}

function getDateTimeJsFromRegional( dateTimeRegional ) {
	var dateRegional = dateTimeRegional[0];
	//if( dateTimeRegional[1] = '' ) dateTimeRegional ;
	var timeRegional = dateTimeRegional[1];
	var dateBits = dateRegional.split( '/' );
	var timeBits = timeRegional.split( ':' );
	var dateJs = new Date( dateBits[2], dateBits[1] - 1, dateBits[0], timeBits[0], timeBits[1] );
	return dateJs;
}

// returns date in ISO format, i.e. YYYY-MM-DD
function getDateIsoFromJs( d ) {
	dMonth = '' + (d.getMonth() + 1);
	if( dMonth.length == 1 ) dMonth = '0' + dMonth;
	dDay = '' + d.getDate();
	if( dDay.length == 1 ) dDay = '0' + dDay;
	dateBits = new Array( d.getFullYear(), dMonth, dDay );
	return dateBits.join( '-' );
}

function getDateJsFromIso( dateIso ) {
	var dateBits = dateIso.split( '-' );
	var dateJs = getJsDate( dateBits[0], dateBits[1], dateBits[2] );
	return dateJs;
}

function getJsDate( year, month, day ) {
	return new Date( year, month - 1, day, 0, 0, 0, 0 );
}

function testDateFuncs() {
	var date1 = new DateModel( getJsDate( 2012, 12, 21 ) );
	var date2 = new DateModel( getJsDate( 2013, 05, 30 ) );	
	var str = 'js1: ' 
		+ date1 + "\nisoFromJs: " + date1.getIso()
		+ ", jsFromIso: " + getDateJsFromIso( date1.getIso() ) 
		+ "\npretty: " + date1.getDatePretty() //( dateJs1, false )
		+ "\nintervalGC: " + date1.getWeekIntervalGC()
		+ "\nintervalPrint: " + date1.getWeekIntervalPretty() // getDateIsoFromJs( dateJs1 ), false ) + '\n'
		+ "\nmonthIntervalGC: " + date1.getMonthInterval() // getDateIsoFromJs( dateJs1 ), true )
		+ "\nmonthIntervalPrint: " + date1.getMonthAndYear() //( getDateIsoFromJs( dateJs1 ), false ) + '\n'
		+ '\n';
	str += 'js2: ' 
		+ date2 + "\nisoFromJs: " + date2.getIso()
		+ ", jsFromIso: " + getDateJsFromIso( date2.getIso() ) 
		+ "\npretty: " + date2.getDatePretty() //( dateJs1, false )
		+ "\nintervalGC: " + date2.getWeekIntervalGC()
		+ "\nintervalPrint: " + date2.getWeekIntervalPretty() // getDateIsoFromJs( dateJs1 ), false ) + '\n'
		+ "\nmonthIntervalGC: " + date2.getMonthInterval() // getDateIsoFromJs( dateJs1 ), true )
		+ "\nmonthIntervalPrint: " + date2.getMonthAndYear() //( getDateIsoFromJs( dateJs1 ), false ) + '\n'
		+ '\n';
	return str;
	$('#dbgDiv').val( str );
}

function log( str ) {
	$('#dbgDiv').val( $('#dbgDiv').val() + str );
}

// Utility : serialize object
function serialize(_obj)
{
   // Let Gecko browsers do this the easy way
   if (typeof _obj.toSource !== 'undefined' && typeof _obj.callee === 'undefined')
   {
      return _obj.toSource();
   }

   // Other browsers must do it the hard way
   switch (typeof _obj)
   {
      // numbers, booleans, and functions are trivial:
      // just return the object itself since its default .toString()
      // gives us exactly what we want
      case 'number':
      case 'boolean':
      case 'function':
         return _obj;
         break;

      // for JSON format, strings need to be wrapped in quotes
      case 'string':
         return '\'' + _obj + '\'';
         break;

      case 'object':
         var str;
         if (_obj.constructor === Array || typeof _obj.callee !== 'undefined')
         {
            str = '[';
            var i, len = _obj.length;
            for (i = 0; i < len-1; i++) { str += serialize(_obj[i]) + ','; }
            str += serialize(_obj[i]) + ']';
         }
         else
         {
            str = '{';
            var key;
            for (key in _obj) { str += key + ':' + serialize(_obj[key]) + ','; }
            str = str.replace(/\,$/, '') + '}';
         }
         return str;
         break;

      default:
         return 'UNKNOWN';
         break;
   }
}

/*	var year = dateJs.getFullYear();
	var month = dateJs.getMonth();
	var day = dateJs.getDate();
	month++;
	month = '' + month;
	if( month.length == 1 ) month = '0' + month;
	// change buttons and entries selection range
	return( year + '-' + month + '-' + day );
}*/

/*function initWeekSelector() {
	var msecPerDay = 24 * 60 * 60 * 1000;
	var msecPerWeek = 7 * msecPerDay;
	var today = new Date(10 * msecPerWeek) ;
	var dotw = getDayOfWeekLocale( today );
	var max = 6 - dotw;
	
	var firstDateOfThisWeek = new Date( today.getTime() - ( dotw * msecPerDay ) );
	var lastDateOfThisWeek = new Date( today.getTime() + ( max * msecPerDay ) );
	max++;
	var firstDateOfNextWeek = new Date( today.getTime() + ( max * msecPerDay ) );
		
	$('#dbgDiv').text( "Dates : [" + getDayOfWeekPretty( firstDateOfThisWeek ) + ' ' + firstDateOfThisWeek + ' => ' + getDateIso( firstDateOfThisWeek )
		+ "]<br>[" + getDayOfWeekPretty( lastDateOfThisWeek ) + ' ' + lastDateOfThisWeek + '=>' + getDateIso( lastDateOfThisWeek )
		+ "]<br>[" + getDayOfWeekPretty( firstDateOfNextWeek ) + ' ' + firstDateOfNextWeek + '=>' + getDateIso( firstDateOfNextWeek ) );
}
*/