/************************************************
 * Class IntervalView = the date selector view  *
 ************************************************/
var IntervalView = function ( elements ) {
    this._elements = elements;
};


/*****************************************
 * Class EntryListView = the entry table *
 *****************************************/
var EntryListView = function ( elements ) {
    this._elements = elements;
 
    var _this = this;


};

EntryListView.prototype = {
 
    show : function() {
        var elems = this._elements;
        var _this = this;
		
		//elems.filters.change(	function(e) { _this._controller.changeFilter( e ) } );
    },
	
	buildEntryListView : function( targetEl, entryList ) {

		// dont forget in this case targetEl is a "standard" (not jQuery) element reference		
		targetEl.innerHTML = '';

		var calendarEntriesTable = document.createElement('table');
		var calendarEntriesTbody = document.createElement('tbody');
		var str, times, rec;
		
		for (var i = 0; i < entryList.length; i++) {
		
			timesStr = ""; recStr = "";
			var startDate, endDate;
			var eventRow1 = document.createElement('tr');

			//// ATTENTION !! ON PEUT AVOIR DETRUIT L'ENTREE A CET INDEX (i) /////

			times = entryList[i].get( "_allTimes" );
			var timeRows = new Array();

			for( var j = 0 ; j < times.length ; j++ ) {
				timeRows[j] = document.createElement('tr');
				if( times[j].startTime[1] == '' ) {
					startDate =	times[j].startTime[0];
					endDate   = times[j].endTime[0];
				}
				else {
					startDate =	times[j].startTime.join( ' à ' );
					endDate   = times[j].endTime.join( ' à ' );
				}
				timesStr = "Du " + startDate + ' au ' + endDate;
				
				var dateCell = document.createElement('td');
				dateCell.appendChild( document.createTextNode(timesStr) );
				dateCell.setAttribute('class', 'times');
				timeRows[j].appendChild(dateCell);
			
			}
			var nameCell = document.createElement('td');
			nameCell.appendChild(document.createTextNode(entryList[i].get( "title" )));
			nameCell.setAttribute('class', 'entry');
			nameCell.setAttribute('id', '' + i );
			nameCell.setAttribute('name', 'entry-' + i );
			  
			eventRow1.appendChild(nameCell);
			calendarEntriesTbody.appendChild(eventRow1);
			for( var j = 0 ; j < times.length ; j++ )
				calendarEntriesTbody.appendChild( timeRows[j] );
		}
		calendarEntriesTable.appendChild(calendarEntriesTbody);
		targetEl.appendChild(calendarEntriesTable);

	}
	
};

/*********************************************
 * Class TimetableView = the time table view *
 *********************************************/

 

 
/****************************************
 * Class EntryEditView = the entry form *
 ****************************************/
var EntryEditView = function ( elements, metadata ) {
    this._elements = elements;
	this._metadata = metadata;
	this._originalStyles;
    var _this = this;

};

/****************************************
 * Class EntryEditView prototype        *
 ****************************************/
EntryEditView.prototype = {
 
	
	/** Attach change events to HTML fields */
	attachChangeEvents : function() {
	
		// Events for FREQ select
		$( '#FREQ' ).change( function( e ) {

			value = $('#FREQ option:selected').val();
			
			if( value == 'WEEKLY' ) $('.fs_repeatondays').show();
			else $('.fs_repeatondays').hide();
			
			intervalVals = new Array( 'DAILY', 'WEEKLY', 'MONTHLY', 'YEARLY' );
			if( hasObj( intervalVals, value ) ) {
				$('*[name=INTERVAL]').removeAttr('disabled');
				$('.fs_interval').show();
			}
			else {
				$('*[name=INTERVAL]').attr('disabled', 'disabled');
				$('.fs_interval').hide();
			}
				
			$( '#label_interval' ).html( { 'DAILY' : 'jour', 'WEEKLY' : 'semaine', 'MONTHLY' : 'mois', 'YEARLY' : 'année' }[value] );

			if( value == 'MONTHLY' ) {
				$('.fs_repeatmonthtype').show();
				if( $('input[name=repeatmonthtype]:checked').val() == 'BYMONTHDAY' ) {
					$('*[name=BYMONTHDAY]').removeAttr('disabled');
					$('*[name=BYDAY]').attr('disabled', 'disabled');
				}
				else {
					$('*[name=BYDAY]').removeAttr('disabled');
					$('*[name=BYMONTHDAY]').attr('disabled', 'disabled');
				}
			}
			else {
				$('.fs_repeatmonthtype').hide();
				$('*[name=BYDAY]').attr('disabled', 'disabled');
				$('*[name=BYMONTHDAY]').attr('disabled', 'disabled');
			}
			
		});
		
		// Events for wholeday checkbox
		$( '#wholeday' ).change( function( e ) {
			if( $(this).is( ':checked' ) ) $( '.fs_hours' ).hide();
			else $( '.fs_hours' ).show();
		});

		// Events for recurrent checkbox
		$( '#recurrent' ).change( function( e ) {
			if( $(this).is( ':checked' ) ) $( '.fs_recurrence' ).show();
			else $( '.fs_recurrence' ).hide();
		});

		// Events for startdate input
		$( '#startdate' ).change( function( e ) {
			if( ! $('*[name=BYMONTHDAY]').is(':disabled') )
				$('*[name=BYMONTHDAY]').val( $(this).val().substring( 0, 2 ) );
			if( ! $('*[name=BYDAY]').is(':disabled') )
				$('*[name=BYDAY]').val( $(this).val() != '' ? getDayofmonth( $(this).val() ) : '' );
		});

		// Events for repeatmonthtype radio
		$( '*[name=repeatmonthtype]' ).change( function( e ) {
			if( $('input[name=FREQ] option:selected').val() == 'MONHTLY' ) {
				if( $('input[name=repeatmonthtype]:checked').val() == 'BYMONTHDAY' ) {
					$('*[name=BYMONTHDAY]').removeAttr('disabled');
					$('*[name=BYDAY]').attr('disabled', 'disabled');
				}
				else {
					$('*[name=BYDAY]').removeAttr('disabled');
					$('*[name=BYMONTHDAY]').attr('disabled', 'disabled');
				}
			}
		});
	},
 
	
	/** Fire the change events on relevant fields */
	triggerChangeEvents : function() {
		$( '#startdate, #FREQ, #wholeday, #recurrent, *[name=repeatmonthtype]' ).trigger( 'change' );
	},
	
	
	/** Executes right after the view is instantiated */
    show : function() {
        var elems = this._elements;
        var _this = this;
		
		this._originalStyles = new Array();
		this._elements.entryFields.each( function(  ) { 
			_this._originalStyles[this.name] = ( $(this).attr( 'style' ) != undefined ) ? $(this).attr( 'style' ) : '';
		} );
		
		this.attachChangeEvents();
		
    },
	
	
	/** Highlights invalid fields, with different colors for different error types */
	showInvalidFields : function( invalidFields ) {

		// styles for different errors
		var styles = {
			'MISSING': 'border: 2px solid red;',
			'BADFORMAT': 'border: 2px solid #ffaa00;',
			'BADVALUE': 'background-color: #ffbbbb;'
		}

		// reset fields to their original style
		for (var key in this._originalStyles ) {
				$( '*[name=' + key + ']' ).attr( 'style', this._originalStyles[key] );
			}

		// for each field of invalidFields, record relevant field's style, and append the new style
		for (var key in invalidFields ) {
			if( invalidFields[key].style == undefined )
				invalidFields[key].style = $( '*[name=' + key + ']' ).attr( 'style' );
			$( '*[name=' + key + ']' ).attr( 'style', styles[invalidFields[key].error] + invalidFields[key].style ); //
		}
	},
	

	/** Fill form with model data */
	fillEntryFields : function( fieldData ) {
		//var msg = '';
		var setters = { 
			'text' : function( elem, value ) { elem.value = value; },
			'select' : function( elem, value ) { $(elem).val( value ); },
			'checkbox' : function( elem, value ) { $(elem).prop('checked', value ); },
			'radio' : function( elem, value ) {
				$( 'input[name=' + elem.name + ']' ).filter( '[value=' + value + ']' ).attr( 'checked', true );
			}
		}
		this._elements.entryFields.each( function(  ) { 
			var nodeName = this.nodeName.toLowerCase();
			var fieldType = this.type;
			var fieldValue = this.value;
			var type = 'text';
			if( nodeName == 'select' ) type = 'select';
			if( ( nodeName == 'input' ) && ( fieldType == 'radio' || fieldType == 'checkbox' ) )
				type = fieldType;

			if( fieldData[this.name] != undefined ) {
				setters[type]( this, fieldData[this.name] );
		//		msg += this.name + '=' + fieldData[this.name] + '\n';
			}
	
		});
		//alert( msg );
	}

};

