<?php
/*
Plugin Name: WP Yoga Timetable NG
Plugin URI: http://benoit.hubert2.free.fr
Description: Gérer l'affichage d'un planning de cours de yoga
Version: 0.3.0beta-20120505
Author: Benoit Hubert
Author URI: http://benoit.hubert2.free.fr
Copyright: 2011 Benoit Hubert

GNU General Public License, Free Software Foundation <http://creativecommons.org/licenses/GPL/2.0/>
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
//$options = get_option( 'wpytt_options' );
//$is_debug_mode = ( $options['debug'] = 'on' );

include('wpytt-settings.php');
include('wp-yoga-timetable-template.php');
include('wp-yoga-timetable-gc.php');

/*
$is_debug_mode = false;

$debug_prefix = $is_debug_mode ? "debug/" : "";
$debug_suffix = $is_debug_mode ? "-debug" : "";

$template_php_file = $debug_prefix . 'wp-yoga-timetable-template' . $debug_suffix . '.php';
global $controls_js_file;
$controls_js_file = $debug_prefix . 'js/wp-yoga-timetable-controls-mooTools' . $debug_suffix . '.js';

include( $template_php_file );
include( 'wp-yoga-timetable-gc.php' );
*/
//$wpytt_subpages['wpytt_options_agenda'] = "Gestion de l'Agenda"; 

//error_reporting( E_STRICT );

$pluginConfig = array(
	'translation-domain' => 'wpytt',
	'custom-post-types' => array(
		'cours-yoga' => array(
			'type-definition' => array(
				'labels' => array(
					'name' 					=> 'Cours',
					'singular_name' 		=> 'Cours',
					'add_new' 				=> 'Ajouter cours',
					'add_new_item'			=> 'Ajouter cours',
					'edit_item' 			=> 'Editer le cours',
					'new_item' 				=> 'Nouveau cours',
					'view_item' 			=> 'Voir cours',
					'search_items'			=> 'Chercher cours',
					'not_found' 			=> 'Aucun cours trouv&eacute;',
					'not_found_in_trash' 	=> 'Aucun cours dans la Corbeille;'
				),
				'public' => true,
				'capability_type' => 'page',
				'supports' => array('title', 'page-attributes' ),
				//!!!!!!!!!!!!!!!!!!!!!!!!!!!! remplacer stylesheet_dir par plugin_dir !!!!!!!!!!!!!!!!!!
				//	  'menu_icon' => get_stylesheet_directory_uri() . '/images/slides.png',
				'menu_position' => 8,
				//'show_ui' => ( current_user_can( 'manage_options' ) ? true : false ),
				'show_ui' => true
			),
			'taxonomies' => array(
				'niveau-cours' => array(  
					'hierarchical' => true,  
					'label' => 'Niveaux de cours',  
					'query_var' => true,  
					'rewrite' => true  
				)
			),
			'meta-boxes' => array( 
				'wpytt_meta_box' => array(
					'title' => 'Caract&eacute;ristiques du cours',
					'context' =>'normal',
					'data' => array(
						'time_params'	=> array(
							'title' => "Paramètres d'horaire",
							'text'  => "Choisissez le jour, l'heure de début et l'heure de fin du cours",
							// function, slug, title, data source, data source column, selected option value, recompute, wrap
							'fields' => array(
								'professeur' => array( 
								'function'	=> 'generic_select',		// Function
								'label'		=> 'Professeur', 	// Field title
								'src_column'=> 'post_title' 			// Data column
								),
								'jour_semaine' => array(
								'function' => 'generic_select',
								'label' => 'Jour',
								'src_column', null
								),
								'heure_debut' => array(
								'function' => 'generic_select',
								'label' => 'Heure de d&eacute;but',
								'src_column' => null
								),
								'heure_fin' => array(
								'function' => 'generic_select',
								'label' => 'Heure de fin',
								'src_column' => null
								)
							)
						),
						'layout_params' => array(
							'title' => "Paramètres de la case",
							'text'  => "Choisissez le modèle utilisé pour afficher la case dans le tableau",
							// function, slug, title, data source, data source column, selected option value, recompute, wrap
							'fields' => array(
								'modele' => array(
								'function' => 'generic_radio',
								'label' =>"Mod&egrave;le d'affichage de la case dans le tableau"
								),
								'modele_custom' => array(
								'function' => 'generic_textarea'
								)
							)
						)
					)
				)
			)
		),
		'time_table' => array(
			'type-definition' => array(
				'labels' => array(
					'name' 					=> "Tableaux d'horaires",
					'singular_name' 		=> "Tableau d'horaires",
					'add_new' 				=> "Ajouter Tableau d'horaires",
					'add_new_item'			=> "Ajouter Tableau d'horaires",
					'edit_item' 			=> "Editer le Tableau d'horaires",
					'new_item' 				=> "Nouveau Tableau d'horaires",
					'view_item' 			=> "Voir Tableau d'horaires",
					'search_items'			=> "Chercher Tableau d'horaires",
					'not_found' 			=> "Aucun Tableau d'horaires trouv&eacute;",
					'not_found_in_trash' 	=> "Aucun Tableau d'horaires dans la Corbeille;"
				),
				'public' => true,
				'capability_type' => 'post',
				'supports' => array('title', 'page-attributes' , 'editor' ),
				//!!!!!!!!!!!!!!!!!!!!!!!!!!!! remplacer stylesheet_dir par plugin_dir !!!!!!!!!!!!!!!!!!
				//	  'menu_icon' => get_stylesheet_directory_uri() . '/images/slides.png',
				'menu_position' => 10,
				//'show_ui' => ( current_user_can( 'manage_options' ) ? true : false ),
				'show_ui' => true
			),
		)
	),
	'option-forms' => array(
		'wpytt_options'	=>	array(
			'title'		=> 'General options',				// Subpage title
			'context'	=> 'edit.php?post_type=cours-yoga',	// Menu this subpage will be hooked to
			'defaults'	=> array(
//						'professeurs_visibles'	=> array( TEACHERS_ALL, 'get_teachers'),
						'granularite'			=> 15,
						'heure_mini'			=> 480,
						'heure_maxi'			=> 1380
			),
			'data'		=> array(
				'teachers'	=> array( 
					'title' => 'Professeurs visibles dans les s&eacute;lecteurs et les contr&ocirc;les du tableau',
					'text'  => 'Cochez le(s) professeur(s) que vous souhaitez voir apparaître dans les cases à cocher du tableau d\'emploi du temps.',
					// function, slug, title, data source, data source column, selected option value, recompute, wrap
					'fields' => array(
						'professeurs_visibles' => array( 
						'function'	=> 'generic_checkbox',		// Function
						'label'		=> 'Professeurs visibles', 	// Field title
						'src_column'=> 'post_title' 			// Data column
						)
					)
				),
				'days'	=> array( 
					'title' => "Jours visibles dans les sélecteurs et dans le tableau d'emploi du temps",
					'text'  => "Cochez le(s) jour(s) que vous souhaitez voir apparaître dans l'emploi du temps.",
					// function, slug, title, data source, data source column, selected option value, recompute, wrap
					'fields' => array(
						'jours_visibles' => array( 
						'function'	=> 'generic_checkbox',		// Function
						'label'		=> 'Jours visibles', 	// Field title
						'src_column'=> null
						)
					)
				),
				'hours'		=> array(
					'title' => 'Heures minimale et maximale pour les s&eacute;lecteurs d&apos;heure',
					'fields' => array(
						'heure_mini' => array( 
						'function'	 => 'generic_select',	// Function for field output
						'data'		 => array( 'WP_Plugin_FormHelper::select_heures', 7, 11, 60 ),
						'label'		 => 'Heure minimale', 	// Field title
						'src_column' => null 				// Data column
						),
						'heure_maxi' => array( 
						'function'	 => 'generic_select',	// Function
						'data'		 => array( 'WP_Plugin_FormHelper::select_heures', 20, 24, 60 ),
						'label'		 => 'Heure maximale', 	// Field title
						'src_column' => null 				// Data column
						),
						'granularite' => array(
						'function'	  => 'generic_select',
						'label'		  => 'Granularit&eacute;',
						'src_column' => null 				// Data column
						) 
					)
				),
				'page_post'	=> array(
					'title' => 'Article/page associé(e) au tableau',
					'text' => 'Indiquez ici l&rsquo;article ou la page contenant le tableau',
					'fields' => array( 
						'page_or_post' => array(
						'function' => 'generic_radio'
						)
					)
				)
			)
		),
		'wpytt_options_css'	=>	array(
			'title'		=> 'Time table styling',
			'context'	=> 'edit.php?post_type=cours-yoga',
			'defaults'	=> array(
				'day_height'	=> 30,
				'sep_height'	=> 20
			/*	'box_models'	=> array( 
					"standard" => "{$linkOpen}$niveaux_str : $heure_debut_pretty &mdash; $heure_fin_pretty{$linkClose}<br>$prof",
					// link open, levels string, start hour pretty, end hour pretty, link close, teacher
					"multiple" => "{$linkOpen}$niveaux_str : d&eacute;but $heure_debut_pretty{$linkClose}<br>$prof<br>$premier_niv_str&nbsp;: fin $heure_fin_pretty",
					"court" => "{$linkOpen}$premier_niv_str : fin $heure_fin_pretty{$linkClose}",
					"custom" => "bla bla" //$linkOpen.$modele_custom.$linkClose
				)*/
			),

			'data'		=> array(
				'stylesheet_params' => array(
					'title' => 'Paramétrage de la feuille de style',
					'fields' => array( 
						'day_width' => array(
						'function'	 => 'generic_select',	// Function
						'data'		 => array( 'WP_Plugin_FormHelper::select_nombres', 80, 180, 10 ),
						'label'		 => 'Largeur jour', 	// Field title
						'src_column' => null 				// Data column
						),
						'hour_height' => array(
						'function'	 => 'generic_select',	// Function
						'data'		 => array( 'WP_Plugin_FormHelper::select_nombres', 15, 60, 5 ),
						'label'		 => 'Hauteur heure', 	// Field title
						'src_column' => null 				// Data column
						),
						'sep_height' => array(
						'function'	 => 'generic_select',	// Function
						'data'		 => array( 'WP_Plugin_FormHelper::select_nombres', 15, 50, 5 ),
						'label'		 => 'Hauteur séparateur', 	// Field title
						'src_column' => null 				// Data column
						),
						'font_size' => array(
						'function'	 => 'generic_select',	// Function
						'data'		 => array( 'WP_Plugin_FormHelper::get_tailles_police' ),
						'label'		 => 'Taille de la police', 	// Field title
						'src_column' => null 				// Data column
						),
						'head_width' => array(
						'function'	 => 'generic_select',	// Function
						'data'		 => array( 'WP_Plugin_FormHelper::select_nombres', 30, 60, 2 ),
						'label'		 => 'Taille de la colonne "Heure"', 	// Field title
						'src_column' => null 				// Data column
						),
						'cell_margin_top' => array(
						'function'	 => 'generic_select',	// Function
						'data'		 => array( 'WP_Plugin_FormHelper::select_nombres', 1, 10, 1 ),
						'label'		 => 'Marge supérieure des cases (pixels)', 	// Field title
						'src_column' => null 				// Data column
						)

					)
				),
				'head_cell_params' => array(
					'title'	 => 'Paramètres des cellules en sommet de colonne',
					'text'	 => "Ces paramètres permettent de spécifier l'apparence des en-têtes de colonnes contenant les jours.",
					'fields' => array(
						'head_cell_padding_top' => array(
						'function'	 => 'generic_select',	// Function
						'data'		 => array( 'WP_Plugin_FormHelper::select_nombres', 2, 30, 2 ),
						'label'		 => 'Espace entre texte et bordure supérieure', 	// Field title
						'src_column' => null 				// Data column
						),
						'head_cell_border_bottom' =>array(
						'function'	 => 'generic_select',	// Function
						'data'		 => array( 'WP_Plugin_FormHelper::select_nombres', 1, 10, 1 ),
						'label'		 => 'Epaisseur de la bordure inférieure', 	// Field title
						'src_column' => null 				// Data column
						),
						'head_cell_height' =>array(
						'function'	 => 'generic_select',	// Function
						'data'		 => array( 'WP_Plugin_FormHelper::select_nombres', 8, 40, 4 ),
						'label'		 => 'Hauteur des cellules', 	// Field title
						'src_column' => null 				// Data column
						),
						'head_cell_color' =>array(
						'function'	 => 'gen_color_picker',	// Function
						'label'		 => 'Couleur de fond', 	// Field title
						'src_column' => null 				// Data column
						)
					)
				),
				'color_params' => array(
					'title' => 'Couleurs associées aux niveaux de cours',
					'text'  => 'Cliquez sur les cases pour choisir la couleur d\'affichage de chaque niveau de cours.',
					'fields' => array( 
						'term_color' => array(
						'multi'		=> true,
						'function'	=> 'gen_color_picker',
						)
					)
				),
				/*'box_models' => array(
					'title' => 'Modèles d\'affichage des cases dans le tableau',
					'text'  => 'Ces "modèles" permettent de spécifier comment sera affichée une case dans le tableau.',
					'fields' => array(
						'box_model' => array(
						'multi' => true,
						'function' => 'gen_box_model'
						)
					)
				),*/
				'table_preview' => array(
					'title' => 'Preview',
					//'text'  => "<iframe id='preview' width='1100' height='500' frameborder='0' scrolling='auto' style='border: 1px solid #eee' src='".plugins_url('/wp-yoga-timetable/wp-yoga-timetable-ajaxFrame.php')."'></iframe>",
					'text'  => "<iframe id='preview' width='1100' height='500' frameborder='0' scrolling='auto' style='border: 1px solid #eee' src='".admin_url('admin-ajax.php?action=my_action')."'></iframe>",
					'fields' => array()
				)

			)
		)
		
	)
);

 class WP_YogaTimeTable_Plugin {

	private $_config;
	//private $_postTypeSlug = 'cours-yoga';
	//private $_taxonomySlug = 'niveau-cours';
	
	private $_path;
	
	private $_subpages;
	private $_trDomain;
	/* Settings object */
	var $settings;
	public $templater;
	var $optSets = array();
	
	private $_optionForms = array();
	private $_postMetaForms = array();
	private $_userMetaForms = array();
	
	
	/**
	 * Class constructor
	 */
	function __construct( $config ) {
		$this->_config = $config;
		$this->_customTypes = $this->_config['custom-post-types'];
		$this->_subpages = $this->_config['option-forms'];
		$this->_trDomain = $this->config['translation-domain'];

		// Get a Settings object instance
		//$this->settings = new WP_YogaTimeTable_Plugin_Settings;
		$this->_path = plugin_dir_path( __FILE__ );
		$this->customTypesInit();
		add_action( 'admin_init', array( $this, 'addMetaBoxes' ) );
		add_action( 'admin_menu', array( $this, 'addAdminPages' ) );
		add_action( 'wp_print_styles', array( $this, 'loadTableCss' ) );
		add_action( 'admin_print_styles', array( $this, 'loadStyles' ) );
		add_action( 'wp_print_scripts', array( $this, 'loadScripts' ) );
		add_action( 'wp_ajax_my_action', array( $this, 'my_action_callback' ) );
		foreach( $this->_subpages as $slug => $data ) {
			$this->settings[$slug] = get_option( $slug );
		}
		$this->templater = new WP_YogaTimeTable_Templater( $this );
		add_filter( 'pre_update_option_wpytt_options', array( $this, 'computeDayHeight' ), 10, 2 );
		add_action( 'update_option_wpytt_options_css', array( $this->templater, 'regenerateCss' ), 10, 2 );
	}
	

	function computeDayHeight( $new, $old ) {
		$new['day_duration'] = $new['heure_maxi'] - $new['heure_mini'];
		return $new;
	}

	function my_action_callback() {
		global $wpdb; // this is how you get access to the database
		
		if( !current_user_can( 'manage_options' ) ) die();
		echo '<html><head><title>AJAX Request</title>';
		$css1 = plugins_url('timetable.css', __FILE__);
		//$css2 = get_stylesheet_directory_uri() . '/style.css';
		echo '<link rel="stylesheet" href="' . $css1 . '" type="text/css" media="screen" />';
		//echo '<link rel="stylesheet" href="' . $css2 . '" type="text/css" media="screen" />';
		echo '<meta http-equiv="Content-Type" content="text/HTML; charset=UTF-8" />';
		echo '</head><body>';
		echo $this->templater->getRenderer()->render( false );
		echo '</body></html>';
		
		die(); // this is required to return a proper result
	}

	function getPath() {
		return $this->_path;
	}

	/**
	 * Register Custom Post Type for Yoga Classes, and associated taxonomy
	 */
	function customTypesInit() {
		foreach( $this->_customTypes as $typeSlug => $typeData ) {
			register_post_type( $typeSlug, $typeData['type-definition'] );
			if( isset( $typeData['taxonomies'] ) )
				foreach( $typeData['taxonomies'] as $taxSlug => $taxData )
					register_taxonomy( $taxSlug, $typeSlug, $taxData );
		}  
	}

	/** Meta box pour enrichir le Custom Post Type "cours-yoga" */
	function addMetaBoxes() {
		foreach( $this->_customTypes as $typeSlug => $typeData )
			if( isset( $typeData['meta-boxes'] ) )
				foreach( $typeData['meta-boxes'] as $boxSlug => $boxParams ) {
					$postMetaForm = new WP_Plugin_PostMetaForm( $this, $boxSlug, $boxParams, $typeSlug );
					//add_meta_box( 	$boxSlug, $boxParams['title'], array($postMetaForm, 'doMetaBox_' . $boxSlug ), 
					//				$typeSlug, $boxParams['context'] );
					$this->_postMetaForms[$boxSlug] = $postMetaForm;
				}
	}
	
	function doMetaBox( $boxSlug ) {
		echo "<input type='hidden' name='meta_boxes[{$boxSlug}]' value='$boxSlug' />";
		
	}

	/** Register the admin subpages */
	function addAdminPages() {
		foreach( $this->_subpages as $slug => $data ) {
//			$this->settings[$slug] = get_option( $slug );
			$optionForm = new WP_Plugin_OptionForm( $this, $slug, $data, $this->_trDomain );
			$this->_optionForms[$slug] = $optionForm;
			$this->optSets[$slug] = $optionForm;
		}
		add_submenu_page( 'edit.php?post_type=cours-yoga', 'Google Agenda', 'Google Agenda', 'manage_options', 'wpytt_options_agenda',
			'wpytt_options_agenda' );
	}

	/**
	 * Display a navigation menu below the page title, to give easier access to this plugin's subpages
	 */
	function formPagesNavMenu( $selected ) {
		echo '<h3>';
		$print_sep = false;
		foreach( $this->_subpages as $slug => $data ) {
			$title_tr = __( $data['title'], $this->_trDomain );
			$separator = $print_sep ? '&nbsp;|&nbsp;' : '';
			$item_class = ( $selected == $slug ) ?  " class='select'" : "";
			echo "$separator<span$item_class><a href='admin.php?page=$slug'>$title_tr</a></span>";
			$print_sep = true;
		}
		echo '</h3>';
	}
	
	/**
	 * Get form slug from its file name (e.g. calling with argument plugindir/forms/myform.php will return myform )
	 */
	function getFormFromFile( $file ) {
		$form = explode( DIRECTORY_SEPARATOR, $file );
		$form = array_reverse( $form );
		$form = substr( $form[0], 0, -4 );
		return $form;
	}

	/**
	 * Get page title from slug
	 */
	function getPageTitle( $slug ) {
		$data = $this->_subpages[$slug];
		return $data['title'];
	}
	
	/**
	 * Load per-page CSS files
	 */
	function loadStyles() {
		global $pagenow;
		if( !current_user_can( 'manage_options' ) ) return;
		
		if( in_array( $pagenow, array( 'post.php', 'post-new.php' ) ) )
			wp_enqueue_style('table_style', plugins_url('/timetables-gen.css', __FILE__) );
		else if( in_array( $pagenow, array( 'edit.php' ) ) && $_GET['post_type'] == 'cours-yoga' ) {
			switch ( $_GET['page'] ) {
				case 'wpytt_options_css' :
					wp_enqueue_style('colorpicker_style_main', plugins_url('/colorpicker/css/colorpicker.css', __FILE__) );
					wp_enqueue_style('colorpicker_style_layout', plugins_url('/colorpicker/css/layout.css', __FILE__) );
					break;
				case 'wpytt_options_agenda' :
					wp_enqueue_style('datepicker_style', plugins_url('/css/ui-lightness/jquery-ui-1.8.16.custom.css', __FILE__) );
					wp_enqueue_style('gc_admin_style', plugins_url('/css/wpytt-gc-admin.css', __FILE__) );
				default :
					break;
			}
		}
	}

	// CSS Tableau
	function loadTableCss() {
		$current_user = wp_get_current_user();
		if ( is_admin() ) return;
		wp_enqueue_style('table_style', plugins_url('/timetable.css', __FILE__) );
		//wp_enqueue_style('checkboxes_style', plugins_url('/cb-css/form.css', __FILE__) );
		//wp_enqueue_style('checkboxes_style', plugins_url('/pretty-checkboxes/css/prettyCheckboxes.css', __FILE__) );
	}
	/** 
	 * Load per-page Javascripts
	 */
	function loadScripts() {
		global $pagenow, $controls_js_file;
		if( !is_admin() ) {
			if( !wp_script_is( 'mootools' ) ) {
				wp_enqueue_script( 'mootools', plugins_url( '/includes/mootools-1.2.2-core-nc.js', __FILE__) );
			}
			wp_enqueue_script( 'wpytt_table_controls', plugins_url( 'js/wp-yoga-timetable-controls-mooTools.js', __FILE__), array( 'mootools' ) );
			//wp_enqueue_script('jquery');
			//wp_enqueue_script( 'wpytt_table_controls', plugins_url( 'cb-css/custom-form-elements.js', __FILE__) );
			//wp_enqueue_script( 'pretty_checkboxes', plugins_url( 'pretty-checkboxes/js/prettyCheckboxes.js', __FILE__) );
			
			
			//wp_enqueue_script( 'wpytt_table_controls', plugins_url( 'js/wp-yoga-timetable-controls.js', __FILE__), array( 'mootools' ) );
		}
		if( !current_user_can( 'manage_options' ) ) return;
		
		if ( in_array( $pagenow, array( 'post.php', 'post-new.php' ) ) ) {
			wp_enqueue_script('wtooltip', plugins_url('js/wtooltip.min.js', __FILE__) );
			wp_enqueue_script('js_utils', plugins_url('js/wp-yoga-timetable.js', __FILE__) );
		}
		else if( in_array( $pagenow, array( 'edit.php' ) ) && $_GET['post_type'] == 'cours-yoga' ) {
			switch ( $_GET['page'] ) {

				case 'wpytt_options_css' :
					wp_enqueue_script('js_colorpicker_main', plugins_url('/colorpicker/js/colorpicker.js', __FILE__) );
					wp_enqueue_script('js_colorpicker_eye', plugins_url('/colorpicker/js/eye.js', __FILE__) );
					wp_enqueue_script('js_colorpicker_utils', plugins_url('/colorpicker/js/utils.js', __FILE__) );
					wp_enqueue_script('js_colorpicker_layout', plugins_url('/colorpicker/js/layout.js', __FILE__) );
					wp_enqueue_script('js_wpytt_colorpicker_client', plugins_url('js/wp-yoga-timetable-coul-niv.js', __FILE__) );
					break;
				
				case 'wpytt_options_agenda' :
					wp_deregister_script('jquery');
					wp_enqueue_script('jquery', plugins_url( 'js/jquery-1.6.2.min.js', __FILE__ ) );
					wp_enqueue_script('jquery_ui', plugins_url( 'js/jquery-ui-1.8.16.custom.min.js', __FILE__ ) );
					wp_enqueue_script('jquery_ui_dp_fr', plugins_url( 'js/jquery-ui.datepicker-fr.js', __FILE__ ) );
					wp_enqueue_script('js_google_calendar', 'http://www.google.com/jsapi?key=ABQIAAAAVzcu66YGicZvSPDVjflWZRQkdwf30UEryoEcWYgVOc_USNqEkxQkdR_BWf8ImhnhR_oQp2C-OaTnJw' );
					//wp_enqueue_script('js_ical_parser', plugins_url( 'js/ijp-0.5.js', __FILE__ ) );
					wp_enqueue_script('js_gc_client_utils', plugins_url( 'js/wpytt-gc-utils.js', __FILE__ ) );
					wp_enqueue_script('js_gc_client_model', plugins_url( 'js/wpytt-gc-model.js', __FILE__ ) );
					wp_enqueue_script('js_gc_client_views', plugins_url( 'js/wpytt-gc-views.js', __FILE__ ) );
					wp_enqueue_script('js_gc_client_controller', plugins_url( 'js/wpytt-gc-controllers.js', __FILE__ ) );
					wp_enqueue_script('js_gc_client', plugins_url( 'js/wpytt-gc.js', __FILE__ ) );
					break;

				default :
					break;
			}
		}

	}

	/**
	 * Magic function related to admin subpages
	 * Each subpage is registered by its "slug"
	 * The associated callback function's name is the slug
	 * This includes a separate filename holding the callback stuff, with the slug as its basename
	 * This avoids bloating the class with HTML stuff
	 */
	//function __call( $name, $arguments ) {
	//}
	
};

add_action( 'init', 'initPlugin', 1 );

function initPlugin() {
	global $wpytt, $pluginConfig;
	$wpytt = new WP_YogaTimeTable_Plugin( $pluginConfig );
//	$wpytt_options = $wpytt->settings;
}


/*

// CSS Admin
function wpytt_load_style_options_styles() {
}
*/







?>