<?php
include('wp-plugin-form-helper.php');
include('wpytt-data-functions.php');

define( 'TEACHERS_ALL', 0xffffff );

define( 'IS_WP_OPTION',		0 );
define( 'IS_WP_POST_META',	1 );
define( 'IS_WP_USER_META',	2 );

class WP_Plugin_OptionForm extends WP_Plugin_GenericForm {

	private $_options;	// only for WP_OPTION
	private $_defaults;
	private $_title;
	private $_slug;
	private $_context;
	
	function __construct( $pluginObj, $optionSlug, $optionData, $trDomain ) {
		parent::__construct( $pluginObj, $optionSlug, $optionData['data'] );
		$this->_defaults = $optionData['defaults'];
		$this->_slug = $optionSlug;
		$this->_context = $optionData['context'];
		//die( $boxSlug . " " . serialize( $boxParams ) );
		//var_dump( $optionData );die();
		$trTitle = __( $optionData['title'], $trDomain );
		$this->_title = $trTitle;
		add_submenu_page( $this->_context, $this->_title, $this->_title, 'manage_options', $this->_slug, array( $this, 'render' ) );
		//add_action( 'admin_menu', array( $this, 'addAdminPage' ) );
		//add_action( 'admin_menu', 'prout' );
		//add_meta_box( 	$boxSlug, $boxParams['title'], array($this, 'doMetaBox' ), //__' . $boxSlug ), 
		//				$typeSlug, $boxParams['context'] );
		$this->load();
//		var_dump( $this->_options );
//		die('never run');		
	}

	//function addAdminPage() {die('here');
		
	//die('never run');
	//}
	
	function render( $arg ) {
		//$form = $this->getFormFromFile( __FILE__ ); 
		$pagetitle = $this->_title;

		global $wpdb;
		//$wpytt_options = $this->settings->getOptions();

		//if( $_POST ) wpytt_options_submit();
		//wpytt_get_options();
		//echo '<div id="update-nag">' . '<b>Get options :</b> '; print_r( $wpytt_options ); echo '</div>';
		?>
		<div id="fsoptions" class="wrap" >
		<?php screen_icon(); ?>
		<h2><?php echo esc_html( $pagetitle ); ?></h2>

		<?php 
		$this->_plugin->formPagesNavMenu( $this->_id );
		?>
		<form action="options.php" method="post">
		<?php 	
		//echo $this->_id;
		//var_dump( $this->_options );
		settings_fields( $this->_id );
		do_settings_sections( $this->_id ); 
		?>
		<input name="Submit" type="submit" class="button-primary" value="<?php esc_attr_e( 'Save Changes' ); ?>" />
		</form>
		<?php 
		global $wpytt;

	}

	function load() {
		$this->_options = get_option( $this->_id );
		//echo $this->_id;
		//var_dump( $this->_options );
		if( empty( $this->_defaults ) ) return;
		foreach( $this->_defaults as $key => $value )
			if( !isset( $this->_options[$key] ) || empty( $this->_options[$key] ) ) {
				//if( count( $value ) == 1 )
				//	continue; //
					$this->_options[$key] = $value;
			}
	}
	function getOptions() {
		return $this->_options;
	}
	
	function get( $name, $sub = null ) {
		//echo "$name $sub<br>";
		//echo $this->_options[$name][$sub];
		//if( $sub != null ) var_dump( $this->_options[$name][$sub] );
		return ( $sub == null ) ? $this->_options[$name] : $this->_options[$name][$sub];
	}
	
	function update() {
		update_option( $this->_id, $this->_options );
	}
	
	function reset() {
		delete_option( $this->_id );
	}
	/**
	 * Magic method to set an option field value
	 */
	function __set( $name, $value ) {
		$this->_options[$name] = $value;
	}
	
	/**
	 * Magic method to get an option field value
	 */
	function __get( $name ) {
		return $this->_options[$name];
	}
	
}

class WP_Plugin_PostMetaForm extends WP_Plugin_GenericForm {

	private $_thePost;
	private $_wpytt;
	
	function __construct( $pluginObj, $boxSlug, $boxParams, $typeSlug ) {
		parent::__construct( $pluginObj, $boxSlug, $boxParams['data'] );
		$this->_wpytt = $pluginObj;
		//die( $boxSlug . " " . serialize( $boxParams ) );
		//die( $this->_id );

		add_meta_box( 	$boxSlug, $boxParams['title'], array($this, 'render' ), //__' . $boxSlug ), 
						$typeSlug, $boxParams['context'] );
		add_action( 'save_post', array( $this, 'submitMetaBox' ) );
		add_filter('wp_insert_post_data', array( $this, 'changeMenuOrder' ), 99, 2);
	}
	
	function render( $thePost, $thisObj ) {
		$this->_thePost = $thePost;
		echo '<br>';
		//var_dump( $args );
		//echo "<input type='hidden' name='meta_boxes[{$boxSlug}]' value='$boxSlug' />";
		echo "<input type='hidden' name='". $this->_id ."[post_id]' value='$thePost->ID' />";
		$this->doSettingsSectionsCustomLayout( $this->_id ); 
		//do_settings_sections( $this->_id );

	}


	function changeMenuOrder($data, $postarr)
	{    
		// If it is our form has not been submitted, so we dont want to do anything
		if(defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) return;

		// Update post 37
		$days = array_keys( getData_jours_visibles() );
		$dayPos = array_search( $postarr['wpytt_meta_box']['jour_semaine'], $days ) + 1;
		$menuOrder = ($dayPos * 1440 ) + ( 0 + $postarr['wpytt_meta_box']['heure_debut'] );

		$data['menu_order'] = $menuOrder;
		return $data;
	}

	function submitMetaBox() {
		$postId = $_POST['wpytt_meta_box']['post_id'];
		// var_dump( $_POST['wpytt_meta_box'] );
		// echo "<br>$postId<br>";
		// die();
		update_post_meta( $postId, 'professeur', $_POST['wpytt_meta_box']['professeur'] );
		update_post_meta( $postId, 'jour_semaine', $_POST['wpytt_meta_box']['jour_semaine'] );
		update_post_meta( $postId, 'heure_debut', $_POST['wpytt_meta_box']['heure_debut'] );
		update_post_meta( $postId, 'heure_fin', $_POST['wpytt_meta_box']['heure_fin'] );
		update_post_meta( $postId, 'modele', $_POST['wpytt_meta_box']['modele'] );
		if( $_POST['wpytt_meta_box']['modele'] == 'custom' ) update_post_meta( $postId, 'modele_custom', $_POST['wpytt_meta_box']['modele_custom'] );
		
	}
	
	function get( $name ) {
		$post_id = $this->_thePost->ID;
		//echo "*$post_id*" . get_post_meta( $post_id, $name, true );
		//return $this->_options[$name];
		return get_post_meta( $post_id, $name, true );
	}
	
	
}

class WP_Plugin_UserMetaForm extends WP_Plugin_GenericForm {

}

class WP_Plugin_GenericForm {
	private $_type;			// should be IS_WP_OPTION, IS_WP_POST_META, or IS_WP_USER_META
	protected $_id;
	private $_structure;	// describes the structure
	protected $_plugin;
	private $_defaults;
	private $_itemId;	// only for POST/USER meta

	function __construct( $pluginObj, $id, $structure ) {
		$this->_id = $id;
		$this->_structure = $structure;
		$this->_plugin = $pluginObj;
		$this->settingsInit();
		//echo "<br><br>$id<br>";
		//var_dump( $structure );
		//die();
	}
	
	/**
	 * Magic method to call a user func
	 */
	function __call( $name, $args ) {
		//echo "<p>__call( name = $name, args = ("  . serialize( $args ) . ")</p>";
		$function_args = explode( '__', $name );
		if( count( $function_args ) < 2 ) {
			echo "<b>Warning : function $name cant be called</b>";
			return;
		}
		$function_name = array_shift( $function_args );
		//echo "<p>Call <span style='color: red;'>$function_name(" . implode( ', ', $function_args ) . ")</span></p>";
		$this->$function_name( $function_args );
	}
	
	/**
	 * Register setting, sections and fields
	 */
	function settingsInit() {
		$setting_name = $this->_id;
		register_setting( $setting_name, $setting_name, array( $this, 'validateSettings' ) );
		$trace = "";

		foreach( $this->_structure as $section_slug => $section_data ) {
			$section_callback_args = $setting_name . '__' . $section_slug;
			$trace .= "<b>** $section_callback_args **</b>";
			add_settings_section( 
				$section_slug, 
				__( $section_data['title'] ), 
				array( $this, 'printSectionText__' . $section_callback_args ), 
				$setting_name 
			);
			//var_dump( $section_data );
			if( array_key_exists( 'fields', $section_data ) )
				foreach( $section_data['fields'] as $field_name => $field_data ) {
					$field_callback_args =  $section_callback_args . '__' . $field_name;
					$trace .= "<b>** $field_callback_args **</b>";
					
					$is_multi = $field_data['multi'] == true;
					//$field_label = $is_multi ? call_user_func( 'getLabels_' . $field_name ) : $field_data['label'];
					$trace = "";
					if( $is_multi ) {
						$sub_fields = call_user_func( 'getLabels_' . $field_name );
						//die( 'getLabels_' . $field_name );
						foreach( $sub_fields as $sub_field => $sub_label ) {
						$subfield_callback_args = $field_callback_args . '__' . $sub_field;
						$trace .= $subfield_callback_args . "\n";
						//if( $field_name == 'box_model' ) die( $trace );
						//echo "$sub_field $sub_label";
							add_settings_field( 
								$sub_field, 
								$sub_label, 
								array( $this, 'printField__' . $subfield_callback_args ), // $field_data['function'], //'toto', //array( $this, 'printField__' . $field_data['function'] ),
								$setting_name, 
								$section_slug );
						}
					}
					
					else {

					//echo $field_name . ' ' ; var_dump( $field_data );die();
					add_settings_field( 
						$field_name, 
						$field_data['label'], 
						array( $this, 'printField__' . $field_callback_args ), // $field_data['function'], //'toto', //array( $this, 'printField__' . $field_data['function'] ),
						$setting_name, 
						$section_slug );
					}
				}
		}
		//die( $trace );
		// not sure this is really useful !
		//$this->load();
	}

	
	/**
	 * Select taxonomy heading text
	 */
	function printSectionText( $args ) {
		$text = $this->_structure[$args[1]]['text'];
//		$text_args = $this->_structure[$args[1]]['text'];
		if( !empty( $text ) )
			echo '<p>' . __( $text ) . '</p>';
		//var_dump( $args );
	}
	
	function printField( $args ) {
		//echo "!!!!!!!! " ; var_dump($args); echo '<br>'; //var_dump( $this->_structure );
		$field_name = $args[2];
		//if( $field_name == 'box_model' ) die( '<br>dead' );		
		//$sub_field_name = count( $args ) > 3 ? $field_name . '[' . $args[3] . ']' : '';
		//if ($is_multi) echo 'multi<br>';
		$sub_field_name = count( $args ) > 3 ?  $args[3] : '';
		$field = $this->_structure[$args[1]]['fields'][$field_name];
		$dataFunc = isset( $field['data'] ) ? $field['data'] : null;
		$is_multi = $field['multi'] == true;
		//var_dump( $field );
		//echo $is_multi ? ' true ' : ' false ' ;
		
		$args_mapping = WP_Plugin_FormHelper::getArgs( $field['function'] );
		//var_dump( $args_mapping );
		//$args_num = $this->_field_helpers_args[$field['function']];
		$args_array = array();
		// option, name, selected, data_src, data_src_column
		//$args_array = array( $args[0], $args[2], 
		//$args_array = array_slice( 
		
		foreach( $args_mapping as $arg )
			switch( $arg ) {
				case 'option' :
					$args_array[] = $args[0];
					break;
				case 'name' :
					$args_array[] = $field_name; //$is_multi ? $sub_field_name : $field_name;
					break;
				case 'sub_name' :
					$args_array[] = $sub_field_name; //$is_multi ? $sub_field_name : $field_name;
					break;
				case 'data_src' : 
					//$args_array[] = array( 'tata', 'toto' );
					if( $dataFunc == null )
						$args_array[] = call_user_func( 'getData_' . $field_name );
					else {//die($field_name);
						$func = array_shift( $dataFunc );
						$args_array[] = call_user_func_array( $func, $dataFunc );
					}
					//$args_array[] = call_user_func( array( $this, 'getData_' . $field_name ) );
					break;
				case 'selected' :
					$field_complete_name = $field_name;
					//if ($is_multi) echo 'multi<br>';
					$field_complete_name .= $is_multi ? "[$sub_field_name]" : '';
					//echo $field_complete_name;
					//echo $is_multi ? "[$sub_field_name]" : ""; //. $is_multi ? $this->get($field_name . "[$sub_field_name]") : $this->get($field_name);
					$args_array[] = $is_multi ? $this->get($field_name, $sub_field_name) : $this->get($field_name);
					//var_dump( $args_array );
					break;
				default :
					$args_array[] = $field[$arg];
			}
		//echo '<b>CALL</b>' . $field['function'] . '(' . implode(',', $args_array) . ')';
		//echo 'user_func: <b>'; var_dump( $args_array ); echo '</b><br>';
		echo call_user_func_array( 'WP_Plugin_FormHelper::' . $field['function'], $args_array );
		/*echo call_user_func(
			$field['function'], 
			$field_name, 
			$field['label'], 
			call_user_func( array( $this, 'getData_' . $field_name ) ), 
			$field['src_column'], 
			$this->_options[$field_name] );
	*/
		//echo '<p>Field : ' . __( $args[0] ) . '</p>';
	}
	
	/**
	 * Validate input : not used yet... Todo : check validity of color field, for manual input
	 */
	function validateSettings( $input ) {
		return $input;
	}
	
	function doSettingsSectionsCustomLayout( $page ) {
		echo $page;
		ob_start();
		do_settings_sections( $page );
		$output = ob_get_contents();
		ob_end_clean();
		$sections = preg_split( '/<h3>(.*)<\/h3>.*/', $output, null, PREG_SPLIT_DELIM_CAPTURE );
		array_shift( $sections );
		//var_dump($sections);
		$limit = count( $sections ) / 2;
		//echo $limit . "<br>";
		for( $i = 0 ; $i < $limit ; $i++ ) {
			$title = array_shift( $sections );
			$content = array_shift( $sections );
			echo "<h4>$title</h4>\n$content\n";
		}
	}
	
	
}

