<?php

function get_table_row( $head, $array, $classes = null ) {
	$row = "<tr>";
	$row .= "<th class='rhead'>$head</th>";
	foreach( $array as $value ) {
		$class = '';
		$pair_bits = explode( ':', $value );
		if( !empty( $classes ) )  $class .= $classes[$pair_bits[0]];
		$row .= "<td class='$class tbcell'>$value</td>";
	}
	$row .= "</tr>";
	return $row;
}

function get_table_mask_row( $head, $array, $classes = null, $mask ) {
	$row = "<tr>";
	$row .= "<th class='rhead'>$head</th>";
	$bitmask_position = 0;
	foreach( $array as $value ) {
		//$pair_bits = explode( ':', $value );
		$pos_mask = 1 << $bitmask_position;
		$bitmask_position++;
		$and_masks = $mask & $pos_mask ;
		$class = ( $and_masks > 0 ) ? 'cgreen' : 'cred';
//		echo "<div class='$class'>$pos_mask $mask $and_masks $class</div>";
		$row .= "<td class='$class tbcell'>$and_masks</td>";
	}
	$row .= "</tr>";
	return $row;
}

function get_sep_div( $msg = "", $class = "" ) {
	return "<div class='$class'>$msg</div>";
}

function get_sep_tr( $msg = "", $class = "" ) {
	return "<tr class='$class'><td colspan='9'>$msg</td></tr>";
}

function get_kva_table( $titre, $kvlist, $classes = null, $mask_algo, $mask_recalc, $mask_cours = null, $mask_js = null ) {
	$has_mask_cours = !empty( $mask_cours );
	$has_mask_js = !empty( $mask_js );
	$kvpairs = explode( ' ', $kvlist );
	$table = "";
	$table .=  !empty( $titre ) ? get_sep_div( $titre, 'titre' ) : "";
	$table .= "<table>";
	$row_titles = array();
	$row_masks = array();
	foreach( $kvpairs as $kvpair ) {
		$pair_bits = explode( ':', $kvpair );
		$row_titles[] = $pair_bits[0];
		$row_masks[] = $pair_bits[1];
	}
	$table .= get_table_row( "Masks", $kvpairs, $classes );
	$table .= get_table_mask_row( "Malg",$kvpairs, null, $mask_algo );
	if(  $has_mask_cours ) {
		$table .= get_table_mask_row( "Mcrs", $kvpairs, null, $mask_cours );
		$table .= get_sep_tr( "", "andmin" );
		//$table .= get_sep_tr( "mA : $mask_algo AND mC : $mask_cours = " . $mask_algo & $mask_cours, "andmax" );
		$mand = (0 + $mask_algo ) & (0 + $mask_cours );
		$table .= get_table_mask_row( "MandA", $kvpairs, null, $mand );
		$table .= get_sep_tr( "", "andmax" );
	}
	$table .= get_table_mask_row( "Mrec", $kvpairs, null, $mask_recalc );
	if(  $has_mask_cours ) {
		$table .= get_table_mask_row( "Mcrs", $kvpairs, null, $mask_cours );
		$table .= get_sep_tr( "", "andmin" );
		//$table .= get_sep_tr( "mR :$mask_rec AND mC : $mask_cours = " . $mask_rec & $mask_cours, "andmax" );
		$mand = (0 + $mask_algo ) & (0 + $mask_cours );
		$table .= get_table_mask_row( "MandR", $kvpairs, null, $mand );
		$table .= get_sep_tr( "", "andmax" );
		}
	if(  $has_mask_js ) {
		$table .= get_table_mask_row( "M-JS", $kvpairs, null, $mask_js );
	}
		
	$table .= "</table>";
		
	return $table . get_sep_div( '', 'medium');
}

function get_classes( $kvlist ) {

	$kvpairs = explode( ' ', $kvlist );
	$row_slugs = array();
	foreach( $kvpairs as $kvpair ) {
		$pair_bits = explode( ':', $kvpair );
		$row_slugs[$pair_bits[0]] = $pair_bits[1];
	}
	return $row_slugs;
}

header('Content-type: text/html'); // define content type as JSON

/** Include the bootstrap for setting up WordPress environment */
include('../../../../wp-load.php');
echo '<html><head><title>AJAX Request</title>';

$css1 = plugins_url('../timetables-gen.css', __FILE__);
$css2 = plugins_url('/debug.css', __FILE__);

echo '<link rel="stylesheet" href="' . $css1 . '" type="text/css" media="screen" />';
echo '<link rel="stylesheet" href="' . $css2. '" type="text/css" media="screen" />';
echo '</head><body></body>';
echo '<h3 class="emp">Ajax Frame</h3>';
//echo '&lt;link rel="stylesheet" href="' . $css2 . '" type="text/css" media="screen" /&gt;';

$param = $_GET['param'];
echo "<div class='emp'>$param</div>";
$param_bits = explode( '|', $param );

// Nb cours
echo "" . $param_bits[2] . " cours affect&eacute;s<br>";
// pmask, nmask algo
echo "Masques algo:" . $param_bits[4] . "<br>";
$masks = explode( ',', $param_bits[4] );
$pmask_algo = $masks[0];
$nmask_algo = $masks[1];
// pmask, nmask recalcul
echo "Masques recalcul&eacute;s" . $param_bits[6] . "<br><br>";
$masks = explode( ',', $param_bits[6] );
$pmask_recalc = $masks[0];
$nmask_recalc = $masks[1];
// PT:1...
echo get_kva_table( 'Comparaison des masques', $param_bits[0], null, $pmask_algo, $pmask_recalc );
// Mn:1...
echo get_kva_table( null, $param_bits[1], get_classes($param_bits[5]), $nmask_algo, $nmask_recalc );
echo get_sep_div( "", "strong" );
// Cours1 ! Cours2
$cours = explode( '!', $param_bits[3] );
foreach( $cours as $cours ) {
	//echo $cours;
	$bits = explode( '/', $cours );
	$titre = $bits[0];
	$masks = explode( ',', $bits[1] );
	$pmask_cours = $masks[0];
	$nmask_cours = $masks[1];
	$pmask_js = $masks[2];
	$nmask_js = $masks[3];
	echo "Complet [$cours]<br>Titre [$titre]<br>Masques [p: $pmask_cours n:$nmask_cours] [pJS: $pmask_js nJS:$nmask_js]<br>";
	echo get_kva_table( $titre, $param_bits[0], null, $pmask_algo, $pmask_recalc, $pmask_cours, $pmask_js );
// Mn:1...
	echo get_kva_table( null, $param_bits[1], get_classes($param_bits[5]), $nmask_algo, $nmask_recalc, $nmask_cours, $nmask_js );
	echo get_sep_div( "", "strong" );
}
// Mn: mn
echo "<br>" . $param_bits[5] . "<br>";

echo '<br>EOT';
echo '</html>';

?>