<?php
/*
Plugin Name: WP Yoga Timetable
Plugin URI: http://benoit.hubert2.free.fr
Description: Gérer l'affichage d'un planning de cours de yoga
Version: 0.7beta-20111030
Author: Benoit Hubert
Author URI: http://benoit.hubert2.free.fr
Copyright: 2011 Benoit Hubert

GNU General Public License, Free Software Foundation <http://creativecommons.org/licenses/GPL/2.0/>
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
//$options = get_option( 'wpytt_options' );
//$is_debug_mode = ( $options['debug'] = 'on' );
$is_debug_mode = false;

$debug_prefix = $is_debug_mode ? "debug/" : "";
$debug_suffix = $is_debug_mode ? "-debug" : "";

$template_php_file = $debug_prefix . 'wp-yoga-timetable-template' . $debug_suffix . '.php';
global $controls_js_file;
$controls_js_file = $debug_prefix . 'js/wp-yoga-timetable-controls-mooTools' . $debug_suffix . '.js';

include( $template_php_file );
include( 'wp-yoga-timetable-gc.php' );

global $wpytt_subpages;
global $subpages_hooks;
global $wpytt_options;

/* Initialisation des tableaux */
$wpytt_subpages = array();
$subpages_hooks = array();
$wpytt_subpages['wpytt_options_general'] = "Options g&eacute;n&eacute;rales";
$wpytt_subpages['wpytt_options_table_style'] = "Mise en forme du tableau de planning"; 
$wpytt_subpages['wpytt_options_agenda'] = "Gestion de l'Agenda"; 
$wpytt_options = array();


function wpytt_options_subpages_menu( $selected ) {
	global $wpytt_subpages;
	echo '<h3>';
	$print_sep = false;
	foreach( $wpytt_subpages as $slug => $title ) {
		$separator = $print_sep ? '&nbsp;|&nbsp;' : '';
		$item_class = ( $selected == $slug ) ?  " class='select'" : "";
		echo "$separator<span$item_class><a href='admin.php?page=$slug'>$title</a></span>";
		$print_sep = true;
	}
	echo '</h3>';
}

function wpytt_menu() {
	global $wpytt_subpages, $subpages_hooks;
	foreach( $wpytt_subpages as $slug => $title )
		$subpages_hooks[$slug] = add_submenu_page( 'edit.php?post_type=cours-yoga', $title, $title, 'manage_options', $slug, $slug );
	}

function wpytt_custom_init() 
{
/* Define Custom Post Type for Yoga Classes */
register_post_type( 'cours-yoga',
    array(
      'labels' => array(
        'name' 					=> 'Cours',
        'singular_name' 		=> 'Cours',
        'add_new' 				=> 'Ajouter cours',
        'add_new_item'			=> 'Ajouter cours',
        'edit_item' 			=> 'Editer le cours',
        'new_item' 				=> 'Nouveau cours',
        'view_item' 			=> 'Voir cours',
        'search_items'			=> 'Chercher cours',
        'not_found' 			=> 'Aucun cours trouv&eacute;',
        'not_found_in_trash' 	=> 'Aucun cours dans la Corbeille;'
      ),
      'public' => true,
      'capability_type' => 'page',
	  'supports' => array('title', 'page-attributes'),
//!!!!!!!!!!!!!!!!!!!!!!!!!!!! remplacer stylesheet_dir par plugin_dir !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//	  'menu_icon' => get_stylesheet_directory_uri() . '/images/slides.png',
	  'menu_position' => 8,
	  'show_ui' => true,
    )
);

register_taxonomy(  
    'niveau-cours',  
    'cours-yoga',  
    array(  
        'hierarchical' => true,  
        'label' => 'Niveaux de cours',  
        'query_var' => true,  
        'rewrite' => true  
    )  
);  

}

function wpytt_init() {
	global $wpytt_options;
	
	/* Meta box pour enrichir le Custom Post Type "cours-yoga" */
	add_meta_box( 'cours_meta', 'Caract&eacute;ristiques du cours', 'cours_meta_form', 
				  'cours-yoga', 'normal' );
	wpytt_get_options();
	
}

/* Scripts JS */
function wpytt_load_scripts() {
	global $pagenow, $controls_js_file;
	if( current_user_can( 'manage_options' ) )
		if ( in_array( $pagenow, array( 'post.php', 'post-new.php' ) ) ) {
			wp_enqueue_script('wtooltip', plugins_url('js/wtooltip.min.js', __FILE__) );
			wp_enqueue_script('js_utils', plugins_url('js/wp-yoga-timetable.js', __FILE__) );
		}
		else if( in_array( $pagenow, array( 'admin.php' ) ) ) {
			if( $_GET['page'] == 'wpytt_options_table_style' ) {
				wp_enqueue_script('js_colorpicker_main', plugins_url('/colorpicker/js/colorpicker.js', __FILE__) );
				wp_enqueue_script('js_colorpicker_eye', plugins_url('/colorpicker/js/eye.js', __FILE__) );
				wp_enqueue_script('js_colorpicker_utils', plugins_url('/colorpicker/js/utils.js', __FILE__) );
				wp_enqueue_script('js_colorpicker_layout', plugins_url('/colorpicker/js/layout.js', __FILE__) );
				wp_enqueue_script('js_wpytt_colorpicker_client', plugins_url('js/wp-yoga-timetable-coul-niv.js', __FILE__) );
			}
			else if( $_GET['page'] == 'wpytt_options_agenda' ) {
				wp_deregister_script('jquery');
				wp_enqueue_script('jquery', plugins_url( 'js/jquery-1.6.2.min.js', __FILE__ ) );
				wp_enqueue_script('jquery_ui', plugins_url( 'js/jquery-ui-1.8.16.custom.min.js', __FILE__ ) );
				wp_enqueue_script('jquery_ui_dp_fr', plugins_url( 'js/jquery-ui.datepicker-fr.js', __FILE__ ) );
				wp_enqueue_script('js_google_calendar', 'http://www.google.com/jsapi?key=ABQIAAAAVzcu66YGicZvSPDVjflWZRQkdwf30UEryoEcWYgVOc_USNqEkxQkdR_BWf8ImhnhR_oQp2C-OaTnJw' );
				wp_enqueue_script('js_ical_parser', plugins_url( 'js/ijp-0.5.js', __FILE__ ) );
				wp_enqueue_script('js_gc_client_utils', plugins_url( 'js/wpytt-gc-utils.js', __FILE__ ) );
				wp_enqueue_script('js_gc_client_model', plugins_url( 'js/wpytt-gc-model.js', __FILE__ ) );
				wp_enqueue_script('js_gc_client_views', plugins_url( 'js/wpytt-gc-views.js', __FILE__ ) );
				wp_enqueue_script('js_gc_client_controller', plugins_url( 'js/wpytt-gc-controllers.js', __FILE__ ) );
				wp_enqueue_script('js_gc_client', plugins_url( 'js/wpytt-gc.js', __FILE__ ) );
			}
		}
	//if( true ) {
	if( !is_admin() ) {
		//wp_enqueue_script('jquery');
		if( !wp_script_is( 'mootools' ) )
			wp_enqueue_script( 'mootools', plugins_url( '/includes/mootools-1.2.2-core-nc.js', __FILE__) );

		wp_enqueue_script( 'wpytt_table_controls', plugins_url( $controls_js_file, __FILE__), array( 'mootools' ) );
	}

}

// CSS Tableau
function wpytt_load_styles() {
	$current_user = wp_get_current_user();
	if (!is_admin()  )
		wp_enqueue_style('table_style', plugins_url('/timetables-gen.css', __FILE__) );
}

function wpytt_load_admin_styles() {
	global $pagenow;
	if( !current_user_can( 'manage_options' ) ) return;
//	add_action( 'admin_print_styles-' . $subpage_hooks['wpytt_options_table_style'], 'wpytt_load_style_options_styles' ); // Marche pas
	if( in_array( $pagenow, array( 'admin.php' ) ) ) {
		if( $_GET['page'] == 'wpytt_options_table_style' ) {
			wp_enqueue_style('colorpicker_style_main', plugins_url('/colorpicker/css/colorpicker.css', __FILE__) );
			wp_enqueue_style('colorpicker_style_layout', plugins_url('/colorpicker/css/layout.css', __FILE__) );
		}
		else if( $_GET['page'] == 'wpytt_options_agenda' ) {
			wp_enqueue_style('datepicker_style', plugins_url('/css/ui-lightness/jquery-ui-1.8.16.custom.css', __FILE__) );
			wp_enqueue_style('gc_admin_style', plugins_url('/css/wpytt-gc-admin.css', __FILE__) );
		}
	}
	 if( in_array( $pagenow, array( 'post.php', 'post-new.php' ) ) )
		wp_enqueue_style('table_style', plugins_url('/timetables-gen.css', __FILE__) );
}

/* CSS Admin */
function wpytt_load_style_options_styles() {
}

function wpytt_recompute_midday_gap() {
	global $wpytt_options, $post;
	$gran = $wpytt_options['granularite'];
	if( $gran == 0 ) $gran = 1;
	$int_debut_bit = 0;
	$int_fin_bit = 1440 / $gran;
	$bits_per_hour = 60 / $gran;
	$borne_inf = $int_fin_bit;
	$borne_sup = $int_debut_bit;
	
	/* Clear mask */
	$mask = array();
	for( $i = 0; $i < $int_fin_bit; $i++ )
		$mask[$i] = false;
	
	/* Set the mask, bit by bit */
	$cours_query = new WP_Query( "post_type=cours-yoga&post_status=publish&orderby=menu_order&order=ASC&posts_per_page=-1" );
	if ( $cours_query->have_posts() ) :
		while( $cours_query->have_posts() ) :
			$cours_query->the_post();
//			echo $post->post_name . '<br>';
			$heure_debut_bit = get_post_meta( get_the_ID(), 'heure_debut', true ) / $gran;
			$heure_fin_bit = get_post_meta( get_the_ID(), 'heure_fin', true ) / $gran;
			for( $index = $heure_debut_bit; $index < $heure_fin_bit; $index++ ) 
				$mask[$index] = true;
		endwhile;
	endif;
	
	/* Get the mask's boundaries */
	for( $i = 0; $i < $int_fin_bit ; $i++ ) {
		if( $mask[$i] && ( $i < $borne_inf ) ) $borne_inf = $i;
		if( $mask[$i] && ( $i > $borne_sup ) ) $borne_sup = $i;
		}

	/* DEBUG 
	$i = 0;
	foreach( $mask as $bit) {
		if( ( $i % 4 ) == 0 ) echo ( !empty( $i) ? "] " : "" ) . "[$i | ";
		echo ( $bit ? '1' : '0' );
		$i++;
		}
	END DEBUG */	
		
	$intervalles = array();
	$i = $borne_inf; $int_deb = 0 ; $int_fin = 0; $num_ints = 0;
	while( $i <= $borne_sup ) {
		if( !$mask[$i] ) {
			//echo "<br>Debut int $i";
			$int_deb = $i;
			while( !$mask[$i] ) $i++;
			$int_fin = $i;
			
			$int_deb_mod = $int_deb % $bits_per_hour;
			if( $int_deb_mod > 0 ) $int_deb += ( $bits_per_hour - $int_deb_mod );
			$int_deb /= 4;
			$int_fin_mod = $int_fin % $bits_per_hour;
			if( $int_fin_mod > 0 ) $int_fin -= $int_fin_mod;
			$int_fin /= 4;

			$int_len = $int_fin - $int_deb;
			if( $int_len == 0 ) continue;
			//echo "<br>Fin int $i";
			//echo "<br>Bornes regulees : $int_deb $int_fin => {$int_len}h<br>";
			
			$intervalles[] = array( 'debut' => $int_deb, 'fin' => $int_fin, 'duree' => $int_len );
			$num_ints++;
			}
		$i++;
	}
	$total_heures_pause = 0;
	foreach( $intervalles as $intervalle ) {
		$total_heures_pause += $intervalle['duree'];
	}
	$wpytt_options['total_heures_pause'] = $total_heures_pause;
	$wpytt_options['intervalles'] = $intervalles;
	wpytt_options_update();
}

/* When the post is saved, saves our custom data */
function wpytt_save_postdata( $post_id ) {
	global $wpytt_options;
	
  // If it is our form has not been submitted, so we dont want to do anything
  if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;
  
  // Check permissions
  if ( 'page' == $_POST['post_type'] ) {
    if ( !current_user_can( 'edit_page', $post_id ) ) return;
  }
  else {
    if ( !current_user_can( 'edit_post', $post_id ) ) return;
  }
  // OK, we're authenticated: we need to find and save the data
	update_post_meta( $post_id, 'professeur', $_POST['select_prof'] );
	update_post_meta( $post_id, 'jour_semaine', $_POST['select_jour'] );
	update_post_meta( $post_id, 'heure_debut', $_POST['select_heure_debut'] );
	update_post_meta( $post_id, 'heure_fin', $_POST['select_heure_fin'] );
	update_post_meta( $post_id, 'modele', $_POST['modele'] );
	if( $_POST['modele'] == 'custom' ) update_post_meta( $post_id, 'modele_custom', $_POST['modele_custom'] );
	
	wpytt_recompute_midday_gap();
}

/* Init actions */
add_action( 'init', 'wpytt_custom_init' );
add_action( 'admin_init', 'wpytt_init' );
add_action( 'admin_menu', 'wpytt_menu' );
add_action( 'wp_print_scripts', 'wpytt_load_scripts' );
add_action( 'admin_print_styles', 'wpytt_load_admin_styles' );
add_action( 'get_header', 'wpytt_load_styles' );
add_action( 'save_post', 'wpytt_save_postdata' );

function pretty_print_heure( $heure_numerique ) {
		 $heure_lisible_h = $heure_numerique / 60;
		 $heure_lisible_m = $heure_numerique % 60;
		 return sprintf( "%2dh%02d", $heure_lisible_h, $heure_lisible_m );
}

if( !function_exists( "select_nombres" ) ) {
function select_nombres( $min, $max, $granularite = 1 ) {
	$tab = array();
	for( $i = $min ; $i <= $max ; $i += $granularite ) $tab[$i] = $i;
	return $tab;
}
}

function select_nombres_float( $min, $max, $granularite = 1 ) {
	$tab = array();
	for( $i = $min ; $i <= $max ; $i += $granularite ) $tab[] = $i;
	return $tab;
}
function get_tailles_police() {
	return select_nombres_float( 8, 16, 0.5 );
}

/* Genere un tableau de choix d'heure */
function select_heures( $limite_basse, $limite_haute, $granularite ) {
	
	if( $limite_basse < 0 || $limite_haute > 24 || $granularite > 60 || ( $granularite % 5) ) return null;
	
	$num_tranches = 60 / $granularite;
	
	$tranche_basse = $limite_basse * $num_tranches;
	$tranche_haute = $limite_haute * $num_tranches;
	$heures = array();
	for( $tranche = $tranche_basse ; $tranche <= $tranche_haute; $tranche++ ) {
		 $cle_heure = $tranche * $granularite;
		 $heure_lisible_h = $cle_heure / 60;
		 $heure_lisible_m = $cle_heure % 60;
		 $heure_lisible = sprintf( "%02dh%02d", $heure_lisible_h, $heure_lisible_m );
		 $heures[$cle_heure] = $heure_lisible;
	}
	
	return $heures;
}

function generic_select( $slug, $title, $data, $object_column, $selected, $recompute = true, $wrap = false, $class='' ) {
	$recompute = ( $recompute ) ? " onchange='recompute();'" : "";
	$output = ( ($wrap) ? "<tr>" : "" ) . "<td><label for='$slug'>$title</label></td>\n"
		. "<td><select id='$slug' class='$class' name='$slug'$recompute style='margin-left: 1.8em; margin-bottom: 0.8em;'>\n";
	foreach( $data as $key => $value ) {
		if( is_object( $value ) ) { 
			$object_vars = get_object_vars( $value );
//			= $value[$object_column];
			$value = $object_vars[$object_column];
		}
		$selected_flag = ( $selected == $key ) ? " selected='selected'" : "";
		$output .= "\t<option value='$key'$selected_flag>$value</option>\n";
		//$output .= '<option value="">' . serialize( $key ) . ' => ' . $value . '</option>';
	}
	$output .= "</select></td>".( ($wrap) ? "</tr>" : "" )."\n";
	return $output;
}

function generic_radio( $group, $slug_title_kva, $checked ) {
	$ouptut = "";
	foreach( $slug_title_kva as $slug => $title ) {
		$checked_flag = ( $checked == $slug ) ? " checked='checked'" : "";
		$output .= "<input type='radio' style='margin-bottom: 6px;' name='$group' value='$slug'$checked_flag>&nbsp;$title</input><br>";
	}
	return $output;
}

/* Meta box pour enrichir le Custom Post Type "cours-yoga" */
function cours_meta_form() {
	// Custom Post Cours and WP DB
	global $post;
	global $wpdb;
	global $wpytt_options;
	
	$hmin = $wpytt_options['heure_minimale'];
	$hmax = $wpytt_options['heure_maximale'];
	$gran = $wpytt_options['granularite'];
	$profs_visibles = $wpytt_options['professeurs_visibles'];
	$profs_visibles_str = "( '" . implode( "', '", $profs_visibles ) . "' )";
	
	// Jour de la semaine : Lundi a Samedi
	$jours = array( 'lundi' => 'Lundi', 'mardi' => 'Mardi', 'mercredi' => 'Mercredi', 
					'jeudi' => 'Jeudi', 'vendredi' => 'Vendredi', 'samedi' => 'Samedi' );
	
	// Profs
	$sql_profs = "SELECT post_name,ID,post_title FROM {$wpdb->posts} WHERE post_type = 'les-professeurs' AND post_name IN $profs_visibles_str";
	$profs = $wpdb->get_results( $sql_profs, OBJECT_K );
	
	// ID and title
	$post_id = $post->ID;
	$title = $post->post_title;
	
	$step = 1440;
	$base = 1440; // pour lundi
	foreach( $jours as $key => $val ) {
		echo "<input type='hidden' id='$key' value='$base' />\n";
		$base += $step;
	}
		
?>
	<table>
	<tr>
	<?php echo generic_select(
		"select_prof", "Professeur", $profs, 'post_title', 
		get_post_meta( $post_id, 'professeur', true ), false ); ?>
	<td rowspan="5" width="10"></td>
	<td rowspan="5" style="border-left: 1px solid #bbc; padding-left: 10px;">
	<label for="modele"><strong>Mod&egrave;le d&apos;affichage de la case dans le tableau</strong></label><br>
	<div style="margin-bottom: 6px;"></div>
	<?php 
		$modele = get_post_meta( $post_id, 'modele', true );
		if( empty( $modele ) ) $modele = 'standard';
		echo generic_radio(	"modele",
							array(	"standard" => "Standard", 
									"multiple" => "Cours &agrave; niveaux multiples (ex : N3-4)", 
									"court" => "Cours court (ex: N4 venant apr&egrave;s cours N3-4)", 
									"custom" => "Particulier (aide <a class='tooltip' href='#'>ici</a>) :" ),
							$modele ); 
	?>
	<textarea name="modele_custom" rows="3" style="margin-left: 1.8em; width: 90%;"><?php
		$modele_custom = get_post_meta( $post_id, 'modele_custom', true );
		$echo_custom = ( $modele == "custom" ) && ( !empty( $modele_custom ) );
		echo ( $echo_custom ) ? $modele_custom : '$niv : $debut à $fin'."\n".'$prof'; 
	?></textarea>
	</td>
	</tr>
	<tr>
	<?php echo generic_select( 
		"select_jour", "Jour", $jours, null, 
		get_post_meta( $post_id, 'jour_semaine', true ) ); ?>
	<td></td>
	</tr>
	<tr>
	<?php echo generic_select( 
	"select_heure_debut", "Heure de d&eacute;but", select_heures( $hmin, $hmax, $gran ), null, 
	get_post_meta( $post_id, 'heure_debut', true ) ); ?>
	<td></td>
	</tr>
	<tr>
	<?php echo generic_select( 
	"select_heure_fin", "Heure de fin", select_heures( $hmin, $hmax, $gran ), null, 
		get_post_meta( $post_id, 'heure_fin', true ) ); ?>
	<td></td>
	</tr>
	
	<tr>
		<td colspan="2">
		<?php
			$niveaux = wpytt_get_niveaux_kva();
			$niveaux_cours = get_the_terms(  $post->ID, 'niveau-cours' );
			$liste_niveaux = array();
			foreach( $niveaux_cours as $niveau ) {
				$liste_niveaux[] = '<span class="'. $niveau->slug . '">&nbsp;' . $niveau->name . '&nbsp;</span>';
				}
			//$liste_niveaux = get_the_term_list( $post->ID, 'niveau-cours', '<strong>Niveau(x):</strong> ', ', ', '' );
			echo 'Niveaux : ' . implode( ', ', $liste_niveaux );
		?>
		</td>
	</tr>
	</table>
	<input type='hidden' id='urlPostTableau' value='<?php echo get_permalink( $wpytt_options['id_post_tableau'] ); ?>' />
<?php
	
}


function generic_checkbox( $slug, $title, $data, $object_column, $checked ) {

	//$output = "<td><label for='$slug'>$title</label></td>\n"
	//	. "<td><select id='$slug' name='$slug'$recompute style='margin-left: 1.8em; margin-bottom: 0.8em;'>\n";
	$output = "<br><h3>$title</h3>\n";
	foreach( $data as $key => $value ) {
		if( is_object( $value ) ) { 
			$object_vars = get_object_vars( $value );
			$value = $object_vars[$object_column];
		}
		if( !empty( $checked ) ) $checked_flag = ( in_array( $key, $checked ) ) ? " checked='checked'" : "";
		$output .= "\t<input type='checkbox' name='cb-{$key}' value='$key'{$checked_flag}/>&nbsp;$value&nbsp;\n";
	}
	return $output;
}

/* This is meant to update plugin options while we're not in the options page, e.g. from midday gap recompute */
function wpytt_options_update() {
	global $wpytt_options;
	update_option( 'wpytt_options', $wpytt_options );
}

function wpytt_options_submit() {

	global $wpytt_options;
	
	//echo '<b>Submit &mdash; POST :</b> '; print_r( $_POST ); echo '<br>';
	/* Checkboxes profs */
	$matches = array();
	$profs_visibles_a = array();
	foreach( $_POST as $key => $value )
		if( preg_match( '/cb-(.)+/', $key, $matches ) > 0 ) $profs_visibles_a[] = $value;
	$wpytt_options['professeurs_visibles'] = $profs_visibles_a;
				
	/* Heures minimale et maximale, granularite */
	if( !empty( $_POST['select_heure_mini'] ) ) $wpytt_options['heure_minimale'] = $_POST['select_heure_mini'] / 60;
	if( !empty( $_POST['select_heure_maxi'] ) ) $wpytt_options['heure_maximale'] = $_POST['select_heure_maxi'] / 60;
	if( !empty( $_POST['select_granularite'] ) ) $wpytt_options['granularite'] = $_POST['select_granularite'];
	if( !empty( $_POST['post_or_page'] ) ) $wpytt_options['post_or_page'] = $_POST['post_or_page'];
	if( !empty( $_POST['select_post'] ) && ( $_POST['post_or_page'] == 'post' ) ) $wpytt_options['id_post_tableau'] = $_POST['select_post'];
	if( !empty( $_POST['select_page'] ) && ( $_POST['post_or_page'] == 'page' ) ) $wpytt_options['id_post_tableau'] = $_POST['select_page'];
	unset( $wpytt_options['slug_post_tableau'] );
	update_option( 'wpytt_options', $wpytt_options );
}

function wpytt_get_options() {
	global $wpytt_options;
	$wpytt_options = get_option( 'wpytt_options' ) ;
/*	foreach( $wpytt_options as $key => $value )
		echo "Key: $key &mdash; Value: "; print_r( $value ); echo "<br>";*/
}

function wpytt_options_general() {
?>
<?php
	global $wpdb;
	global $wpytt_subpages;
	global $wpytt_options;
	$pagetitle = $wpytt_subpages[__FUNCTION__];
	if( $_POST ) wpytt_options_submit();
	wpytt_get_options();
	//echo '<div id="update-nag">' . '<b>Get options :</b> '; print_r( $wpytt_options ); echo '</div>';
	?>
	<div id="fsoptions" class="wrap" >
	<?php screen_icon(); ?>
	<h2><?php echo esc_html( $pagetitle ); ?></h2>

	<?php
	wpytt_options_subpages_menu( __FUNCTION__ );

	// Profs
	$sql_profs = "SELECT post_name,ID,post_title FROM {$wpdb->posts} WHERE post_type = 'les-professeurs'";
	$profs = $wpdb->get_results( $sql_profs, OBJECT_K );
	?>
	<form method="post" action="admin.php?page=wpytt_options_general">
	<table>
	<?php 
		echo '<tr>' .generic_checkbox( 'prof_checkboxes', 'Professeurs visibles dans les s&eacute;lecteurs et les contr&ocirc;les du tableau', 
			$profs, 'post_title', 
			$wpytt_options['professeurs_visibles']
			) . '</tr></table>';
		echo "<br><h3>Heures minimale et maximale pour les s&eacute;lecteurs d&apos;heure</h3>\n<table>";
		echo generic_select(
			"select_heure_mini", "Heure minimale", select_heures( 7, 10, 60 ), null, 
			$wpytt_options['heure_minimale'] * 60, false, true );
		echo generic_select(
			"select_heure_maxi", "Heure maximale", select_heures( 20, 23, 60 ), null, 
			$wpytt_options['heure_maximale'] * 60, false, true );
		$granularites = array( '5' => '5 minutes', '10' => '10 minutes', '15' =>'15 minutes', '20' => '20 minutes', '30' => '30 minutes' );
		echo generic_select( 
			"select_granularite", "Granularit&eacute;", $granularites, null, 
			$wpytt_options['granularite'], false, true ); 
		echo "</table>";
		
		echo "<h3>Indiquez ici l&rsquo;article ou la page contenant le tableau</h3>";
		
		$sql = "SELECT ID,post_title FROM {$wpdb->posts} WHERE post_type = 'post' AND post_status = 'publish'";
		$posts = $wpdb->get_results( $sql, OBJECT_K );
		$select_post = generic_select( 
			"select_post", "Article", $posts, 'post_title', 
			$wpytt_options['id_post_tableau'], false, true ); 
		
//		$sql = "SELECT ID,post_title FROM {$wpdb->posts} WHERE post_type = 'page' AND post_status = 'publish'";
		$sql = "SELECT ID,post_title FROM {$wpdb->posts} WHERE post_type = 'page'";
		$posts = $wpdb->get_results( $sql, OBJECT_K );

		$select_page = generic_select( 
			"select_page", "Page", $posts, 'post_title', 
			$wpytt_options['id_post_tableau'], false, true ); 
		
		$post_or_page = $wpytt_options["post_or_page"];
		echo generic_radio(	"post_or_page",
							array(	"post" => $select_post, 
									"page" => $select_page ), 
							(!empty( $post_or_page)) ? $post_or_page : "post" ); 
		
	?>

	<p class="submit">
	<input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
	</p>
	</form>
<?php
}

function wpytt_regenerate_css() {

	global $wpytt_options;
	$css_vars = $wpytt_options['css'] ;
	
	/* Get colors */
	$niveauxCouleurs = array_flip( $css_vars['couleurs_niv'] );
	$terms_niveaux = wpytt_get_niveaux( 'DESC' );
	$css = "/* Colors */\n";
	foreach( $terms_niveaux as $term_niveau ) {
		$niveau = $term_niveau->slug;
		$couleur = $niveauxCouleurs[$niveau];
		$css .= "
.$niveau , ._$niveau {
\tbackground: #$couleur;
}
";
	}
	
	/* Open CSS template and fill an array with its lines */
	$thisfile = basename( __FILE__ );
	$thispath = str_replace( $thisfile, '', __FILE__ );
	$fh = fopen( $thispath . 'timetables-niv.template.css', 'r' );
	while( $line = fgets( $fh ) ) $css .= $line;
	fclose( $fh );

	foreach( $css_vars as $var => $value ) {

			/* Decrement hours heights */
			if( $var == 'heure_h' || $var == 'sep_h' ) $value -= 1;

			/* Translate font choice  in px */
			if( $var == 'font_size' ) {
				$tailles = get_tailles_police();
				$value = $tailles[$value];
			}
	
			$css = str_replace( "[$var]", $value, $css );
		}

	$lines = explode( "\n", $css );
	$fh = fopen( $thispath . 'timetables-gen.css', 'w+' );
	foreach( $lines as $line ) fputs( $fh, $line );
	fclose( $fh );
}

function wpytt_options_style_submit() {

	global $wpytt_options;
	if( isset( $wpytt_options['css'] ) ) $css_vars = $wpytt_options['css'] ;
	else $css_vars = array();
	
	/* Heures minimale et maximale, granularite */
	if( !empty( $_POST['select_larg_jour'] ) ) $css_vars['jour_w'] = $_POST['select_larg_jour'];
	if( !empty( $_POST['select_haut_heure'] ) ) $css_vars['heure_h'] = $_POST['select_haut_heure'];
	if( !empty( $_POST['select_haut_sep'] ) ) $css_vars['sep_h'] = $_POST['select_haut_sep'];
	$num_pauses = count( $wpytt_options['intervalles'] );
	$css_vars['jour_h'] = ( ( $wpytt_options['heure_maximale'] -  $wpytt_options['heure_minimale'] - $wpytt_options['total_heures_pause'] ) * $css_vars['heure_h'] ) + ( $num_pauses * $css_vars['sep_h'] ) + 35;

	/* Font */
		if( !empty( $_POST['select_font_size'] ) ) $css_vars['font_size'] = $_POST['select_font_size'];

	/* Couleurs */
	$colors = array();
	$couleursNiveaux = array();
	for( $i = 0 ; $i < 16 ; $i++ ) {
		$color_i = $_POST['colorpickerField-'.$i];
		$niv_i = $_POST['coulNivField-'.$i];
		if( !empty( $color_i ) && ($color_i != '#' ) ) { 
			$colors[] = $color_i;
			if( $niv_i != "none" ) $couleursNiveaux[$color_i] = $niv_i;
			}
		}
	$css_vars['couleurs_niv'] = $couleursNiveaux;
	$css_vars['colors'] = $colors;
	
	/*  Injection des variables CSS dans les options globales*/
	$wpytt_options['css'] = $css_vars;
	
	update_option( 'wpytt_options', $wpytt_options );
	wpytt_regenerate_css();
}

function wpytt_get_niveaux( $order = 'ASC' ) {
	$args = array( 'hide_empty' => false, 'orderby' => 'slug', 'order' => $order );
	$terms = get_terms( 'niveau-cours', $args );
	return $terms;
}
function wpytt_get_niveaux_kva( $default = 'None') {
	$terms_kva = array();
	if( !empty( $default ) ) $terms_kva['none'] = $default;
	$terms = wpytt_get_niveaux( 'ASC' );
	foreach( $terms as $term ) $terms_kva[$term->slug] = $term->description;
	return $terms_kva;
}

/* Time table style options */
function wpytt_options_table_style() {
	global $wpytt_subpages;
	global $wpytt_options;
	$pagetitle = $wpytt_subpages[__FUNCTION__];
	//if( $_POST ) fst_options_colors_submit();
	if( $_POST ) wpytt_options_style_submit();
	wpytt_get_options();
	//echo '<div id="update-nag">' . '<b>Get options :</b> '; print_r( $wpytt_options ); echo '</div>';
	//var_dump( $_POST );
?>

<div id="fsoptions" class="wrap" >
<?php screen_icon(); ?>
<h2><?php echo esc_html( $pagetitle ); ?></h2>
<form method="post" action="admin.php?page=wpytt_options_table_style">

<?php
wpytt_options_subpages_menu( __FUNCTION__ );

	$css_variables = $wpytt_options['css'];
	
	echo "<br><h3>Param&eacute;trage de la feuille de style</h3>\n<table>";
	$tailles = select_nombres( 80, 160, 10 );
	echo generic_select( 
		"select_larg_jour", "Largeur jour", $tailles, null, 
		$css_variables['jour_w'], false, false ); 
	$tailles = select_nombres( 15, 50, 5 );
	echo generic_select( 
		"select_haut_heure", "Hauteur heure", $tailles, null, 
		$css_variables['heure_h'], false, false ); 
	echo generic_select( 
		"select_haut_sep", "Hauteur s&eacute;parateur", $tailles, null, 
		$css_variables['sep_h'], false, false ); 
	$tailles_police = get_tailles_police();
	echo generic_select( 
		"select_font_size", "Taille de la police", $tailles_police, null, 
		$css_variables['font_size'], false, false ); 
	echo '</table>';
	?>

	<h3>Couleurs et correspondances avec les niveaux</h3>
	<p>Cliquez sur les cases pour modifier les couleurs, puis associez chaque couleur &agrave; un niveau.</p>
	<?php
	$term_select_options = wpytt_get_niveaux_kva( '---' );
	$couleursNiveaux = $css_variables['couleurs_niv'];
	
	if( count( $css_variables['colors'] ) == 0 )
		$css_variables['colors'] = array( '55bbdd', 'aadd88', 'ffff33', 'eeaa34', 'ff7733', 'bbaacc', '00ff00', '0000ff', 'ff0000', 'ffff00', 'ff00ff', '00ffff', '444444', '888888',  'cccccc' );
	$rows = 4;
	$cols = 3;
	$ic = 0; $ir = 0;
	
	echo "<table>\n";
	foreach( $css_variables['colors'] as $color ) :
		if( $ic == 0 ) echo "<tr style='margin: 0; padding: 0;'>\n";
			$pickerFieldId = 'colorpickerField-' . ( $ir * $cols + $ic );
			$selectFieldBaseName = 'coulNivField'; // '-' . ( $ir * $cols + $ic );
			//echo get_picker
			echo " <td style='padding: 0 10px 10px 70px; margin: 0 0 0 0;'>\n";
			echo "<p><input type='text' maxlength='4' size='4' id='$pickerFieldId' name='$pickerFieldId' class='colorpickerField' value='$color' style='background-color: #$color' /></p>\n</td>\n";
			echo generic_select( $selectFieldBaseName . '-' . ( $ir * $cols + $ic ), "Niveau", $term_select_options, null, $couleursNiveaux[$color], false, false, 
											$selectFieldBaseName . ' ' . $couleursNiveaux[$color]); 
			$ic++;
			if( $ic == $cols ) { echo "</tr>\n"; $ir++; $ic = 0; }
	endforeach;
	if( ($ic > 0) && ($ic < $cols) ) echo "</tr>\n";
	echo "</table>\n";
	
	echo '<h3>Visualiser le tableau (il faut enregistrer les modifications pour mettre &agrave; jour ce cadre)</h3>';
	$url = plugins_url('/wp-yoga-timetable-ajaxFrame.php', __FILE__) ;
	echo "<iframe id='preview' width='1100' height='500' frameborder='0' scrolling='auto' style='border: 1px solid #eee' src='$url'></iframe>";
	?>

	<p class="submit">
	<input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
	</p>
	</form>
	</div>
<?php

}
  
?>